<TeXmacs|1.99.5>

<style|<tuple|beamer|mathemagix|vdh|pari|caas>>

<\body>
  <screens|<\shown>
    \;

    <\with|par-mode|center>
      <strong|<\with|font-base-size|15>
        Fast integer multiplication
      </with>>

      David Harvey, <strong|Joris van der Hoeven>, Grgoire Lecerf

      <small|CNRS, cole polytechnique>
    </with>

    <\with|par-mode|center>
      <tabular*|<tformat|<cwith|1|1|2|2|cell-valign|c>|<table|<row|<cell|
      >|<cell|>|<cell|>>|<row|<cell|>|<cell|<img|<image|texmacs-chip.ps|0.6w|0.6h||>>>|<cell|>>|<row|<cell|>|<cell|>|<cell|>>|<row|<cell|>|<cell|<strong|LIX,
      December 15, 2016<rsub|<math|<rsub|>>>>>|<cell|>>|<row|<cell|>|<cell|<verbatim|http://www.<anim-repeat|<anim-compose|<anim-constant|<with|color|brown|T<space|-0.2spc><with|color|brown|<rsub|<with|math-level|0|font-shape|small-caps|e>>>X<space|-0.2spc>><with|color|dark
      green|<rsub|<with|math-level|0|font-shape|small-caps|m<space|-0.2spc>a<space|-0.4spc>c<space|-0.2spc>s>>>|1sec>|<anim-constant|<with|color|dark
      green|T<space|-0.2spc><with|color|brown|<rsub|<with|math-level|0|font-shape|small-caps|e>>>X<space|-0.2spc>><with|color|brown|<rsub|<with|math-level|0|font-shape|small-caps|m<space|-0.2spc>a<space|-0.4spc>c<space|-0.2spc>s>>>|1sec>>>.org>>|<cell|>>>>>
    </with>

    \;
  </shown>|<\hidden>
    <tit|Integer multiplication for sale>

    \;

    <htab|5mm><image|wikipedia.png|1133px|747px||><htab|5mm>
  </hidden>|<\hidden>
    <tit|Better integer multiplication in stock for YOU>

    <\compact>
      <section*|Computational complexity>

      <\itemize>
        <item><hlink|P versus NP problem|https://en.wikipedia.org/wiki/P_versus_NP_problem>
        (often written as ``P = NP\Q)

        <item>What is the relationship between
        <hlink|BQP|https://en.wikipedia.org/wiki/BQP> and
        <hlink|NP|https://en.wikipedia.org/wiki/NP_%28complexity%29>?

        <item><hlink|NC = P problem|https://en.wikipedia.org/wiki/NC_%3D_P_problem>
        ...
      </itemize>

      <section*|Polynomial vs non-polynomial time for specific algorithmic
      problems>

      <\itemize>
        <item>Can <hlink|integer factorization|https://en.wikipedia.org/wiki/Integer_factorization>
        be done in <hlink|polynomial time|https://en.wikipedia.org/wiki/Polynomial_time>?

        <item>Is <hlink|integer factorization|https://en.wikipedia.org/wiki/Integer_factorization>
        <hlink|NP-complete|https://en.wikipedia.org/wiki/NP-complete>?

        <item>Can <hlink|clustered planar
        drawings|https://en.wikipedia.org/wiki/Clustered_planarity> be found
        in polynomial time? ...
      </itemize>

      <section*|Other algorithmic problems>

      <\itemize>
        <marked|<item>What is the fastest <hlink|algorithm for
        multiplication|https://en.wikipedia.org/wiki/Multiplication_algorithm#Fast_multiplication_algorithms_for_large_inputs>
        of two <with|font-shape|italic|n>-digit numbers?>

        <item>What is the fastest <hlink|algorithm for matrix
        multiplication|https://en.wikipedia.org/wiki/Matrix_multiplication_algorithm>?

        <item>Can the <hlink|Schwartz\UZippel
        lemma|https://en.wikipedia.org/wiki/Schwartz%E2%80%93Zippel_lemma>
        for <hlink|polynomial identity testing|https://en.wikipedia.org/wiki/Polynomial_identity_testing>
        be derandomized?

        <item>Can a <hlink|depth-first search
        tree|https://en.wikipedia.org/wiki/Tr%C3%A9maux_tree> be constructed
        in <hlink|NC|https://en.wikipedia.org/wiki/NC_%28complexity%29>?

        <item>Does <hlink|linear programming|https://en.wikipedia.org/wiki/Linear_programming#Open_problems_and_recent_work>
        admit a <hlink|strongly polynomial|https://en.wikipedia.org/wiki/Time_complexity#Strongly_and_weakly_polynomial_time>-time
        algorithm?

        <item>What is the lower bound on the complexity of <hlink|fast
        Fourier transform|https://en.wikipedia.org/wiki/Fast_Fourier_transform>
        algorithms? ...
      </itemize>

      <section*|Programming language theory ...>

      <section*|Other problems ...>
    </compact>
  </hidden>|<\hidden>
    <tit|Computational models>

    <unroll|<\shown>
      <\compact>
        <strong|Sequential <em|<abbr|vs.>> parallel>

        We will consider sequential algorithms<vspace|1fn>
      </compact>
    </shown>|<\hidden*>
      <strong|Turing machines>

      Turing machines with a finite number of tapes [Papadimitriou
      94]<vspace|1fn>
    </hidden*>|<\hidden*>
      <strong|Other bit complexity models>

      <\compact>
        <\itemize>
          <item>Operations on <math|log n>-bit numbers in time
          <math|O<around*|(|1|)>>

          <item>Random access machine (RAM)<vspace|1fn>
        </itemize>
      </compact>
    </hidden*>|<\hidden*>
      <strong|\S Straight Line Programs \T (SLPs)>

      DAGs, non branching programs [Brgisser\UClausen\UShokrollahi
      97]<vspace|1fn>
    </hidden*>|<\hidden*>
      <strong|Other algebraic complexity models>

      <\compact>
        <\itemize>
          <item>Turing machines with entries in model-theoretic structures
          <math|\<frak-S\>> [Friedman 69]

          <item>BSS machines [Blum\UShub\USmale 89]
        </itemize>
      </compact>
    </hidden*>>
  </hidden>|<\hidden>
    <tit|Construction versus destruction>

    <unroll|<\shown>
      <htab|5mm><tree|SAT|0-1 Integer programming|<tree|Clique|Set
      packing|<tree|Vertex cover|Set covering|...>>|<tree|3-SAT|<tree|Chromatic
      number|Clique cover|<tree|Exact cover|...>>>><htab|5mm>
    </shown>|<\hidden*>
      <with|gr-mode|<tuple|edit|spline>|gr-frame|<tuple|scale|1cm|<tuple|0.500001gw|0.499999gh>>|gr-geometry|<tuple|geometry|1par|0.365187par|bottom>|gr-grid|<tuple|empty>|gr-grid-old|<tuple|cartesian|<point|0|0>|1>|gr-edit-grid-aspect|<tuple|<tuple|axes|none>|<tuple|1|none>|<tuple|10|none>>|gr-edit-grid|<tuple|empty>|gr-edit-grid-old|<tuple|cartesian|<point|0|0>|1>|gr-text-at-halign|center|gr-text-at-valign|center|<graphics||<with|text-at-valign|center|text-at-halign|center|<math-at|\<times\><rsub|\<bbb-K\><around*|[|x|]>>|<point|-2|-3.5>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|\<times\><rsub|\<bbb-Z\>>|<point|-5|-3.5>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|\<div\><rsub|\<bbb-Z\>>|<point|-9.0|-2.0>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|gcd<rsub|\<bbb-Z\>>|<point|-7.0|-2.0>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|\<div\><rsub|\<bbb-K\><around*|[|x|]>>|<point|-3.5|-2.0>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|gcd<rsub|\<bbb-K\><around*|[|x|]>>|<point|-1.5|-2.0>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|+<rsub|\<bbb-Q\>>,\<times\><rsub|\<bbb-Q\>>|<point|-8.0|-0.5>>>|<line|<point|-9|-2.41151>|<point|-5.59379547559201|-3.5>>|<line|<point|-7|-2.3>|<point|-5.59379547559201|-3.08848723376108>>|<line|<point|-8|-0.952325>|<point|-7.3|-1.7>>|<line|<point|-2.3|-3.02917>|<point|-3.5|-2.47082947479825>>|<line|<point|-1.8|-3>|<point|-1.8|-2.4>>|<with|text-at-valign|center|text-at-halign|center|<math-at|\<mathpi\>|<point|-11.0|2.0>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|exp<rsub|\<bbb-C\>>|<point|-9.7|2.0>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|log<rsub|\<bbb-C\>>|<point|-8.2|2.0>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|J<rsub|n>|<point|-7.0|2.0>>>|<with|text-at-valign|center|text-at-halign|center|<text-at|Holonomic
      functions|<point|-8|0.6>>>|<line|<point|-5.3|-3>|<point|-6.3|0.196702606164837>>|<line|<point|-9.4|1.00329>|<point|-11.0|1.67735480883715>>|<line|<point|-8.8|1.00329>|<point|-9.5|1.7>>|<line|<point|-8|1.00329>|<point|-8.0|1.6>>|<line|<point|-7.5|1.00329>|<point|-7.0|1.55850641619262>>|<line|<point|-5|-3>|<point|-5.0|3.04025003307316>>|<with|text-at-valign|center|text-at-halign|center|<math-at|\<times\><rsub|\<bbb-K\><around*|[|x<rsub|1>,\<ldots\>,x<rsub|n>|]>>|<point|-3.0|-0.5>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|\<times\><rsub|\<bbb-K\><around*|[|<around*|[|x|]>|]>>|<point|0|-0.5>>>|<with|text-at-valign|center|text-at-halign|center|<text-at|D-algebraic
      series|<point|-2|1.4>>>|<with|text-at-valign|center|text-at-halign|center|<text-at|Random
      generation|<point|1|2.5>>>|<spline|<point|-1.09636|-3.02917>|<point|0.0|-2.0>|<point|-1.6|-0.970829474798254>>|<spline|<point|-1|-3.4>|<point|0.5|-2.5>|<point|0.5|-1.0>>|<line|<point|0|-0.0291705>|<point|-2.0|0.940236803810028>>|<line|<point|0.5|0>|<point|1.0|2.04025003307316>>|<with|text-at-valign|center|text-at-halign|center|<math-at|\<times\><rsub|\<bbb-K\><rsup|n\<times\>n>>|<point|5.0|-3.5>>>|<with|text-at-valign|center|text-at-halign|center|<text-at|Linear
      systems|<point|9|-2.5>>>|<line|<point|6.08237|-3.5>|<point|9.0|-2.95168011641752>>|<line|<point|-2.9|1.85973673766371>|<point|-4.4|3.04025003307316>>|<with|text-at-valign|center|text-at-halign|center|<text-at|LLL|<point|3.7|-0.7>>>|<with|text-at-valign|center|text-at-halign|center|<text-at|Pad-Hermite|<point|3.6|-1.4>>>|<line|<point|5|-3.06896>|<point|4.3|-1.80329739383516>>|<spline|<point|-1.0|-3.8>|<point|1.3|-3.0>|<point|2.7|-1.80329739383516>>|<spline|<point|-1|-3.6>|<point|0.5|-3.0>|<point|1.7|-0.4>|<point|2.9|0.604775763989946>>|<line|<point|3.69999|-0.304786>|<point|3.69999338536844|0.604775763989946>>|<with|text-at-valign|center|text-at-halign|center|<text-at|Grbner
      bases|<point|9.5|-1>>>|<line|<point|9.2|-2.04832>|<point|9.5|-1.40329408651938>>|<with|dash-style|wave|<line|<point|-11.3466|4.09153>|<point|11.3797459981479|4.05885368434978>>>|<with|text-at-valign|center|text-at-halign|center|<text-at|Integration
      dynamical systems|<point|-5.23614234687128|3.35631366582881>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|\<zeta\><around*|(|k|)>|<point|-5.8|2.0>>>|<line|<point|-7|1.00329>|<point|-6.0|1.6>>|<with|text-at-valign|center|text-at-halign|center|<text-at|Linear
      diff eqs over <math|\<bbb-K\><around*|[|x|]>>|<point|8.4|2.0>>>|<with|text-at-valign|center|text-at-halign|center|<text-at|Factoring
      over <math|\<bbb-Q\>,\<bbb-F\><rsub|p>,\<ldots\>>|<point|4.3|1.0>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|\<times\><rsub|\<bbb-K\><around*|[|x,\<partial\>/\<partial\>
      x|]>>|<point|9.3|0.6>>>|<spline|<point|5.5|-3.06896>|<point|6.5|-1.2>|<point|7.8|0.4>>|<line|<point|8.8|1.0>|<point|9.2|1.6>>>>
    </hidden*>>
  </hidden>|<\hidden>
    <tit|Layered design of fast algorithms>

    <with|gr-mode|<tuple|edit|line>|gr-frame|<tuple|scale|1cm|<tuple|0.5gw|0.5gh>>|gr-geometry|<tuple|geometry|1par|0.6par>|gr-grid|<tuple|empty>|gr-grid-old|<tuple|cartesian|<point|0|0>|1>|gr-edit-grid-aspect|<tuple|<tuple|axes|none>|<tuple|1|none>|<tuple|3|none>>|gr-edit-grid|<tuple|empty>|gr-edit-grid-old|<tuple|cartesian|<point|0|0>|1>|gr-text-at-halign|center|gr-text-at-valign|center|gr-grid-aspect|<tuple|<tuple|axes|#808080>|<tuple|1|#c0c0c0>|<tuple|3|#e0e0ff>>|gr-grid-aspect-props|<tuple|<tuple|axes|#808080>|<tuple|1|#c0c0c0>|<tuple|3|#e0e0ff>>|gr-arrow-end|\<gtr\>|<graphics||<with|fill-color|pastel
    yellow|<cline|<point|-10.6667|4.66667>|<point|-10.6666666666667|3.33333333333333>|<point|10.6666666666667|3.33333333333333>|<point|10.6666666666667|4.66666666666667>>>|<with|text-at-valign|center|text-at-halign|center|<text-at|Higher
    level routines: Cantor\UZassenhaus, LLL, special functions, Galois
    groups|<point|0|4>>>|<with|fill-color|pastel
    yellow|<cline|<point|-10.6667|1.66667>|<point|10.6666666666667|1.66666666666667>|<point|10.6666666666667|0.333333333333333>|<point|-10.6666666666667|0.333333333333333>>>|<with|text-at-valign|center|text-at-halign|center|<text-at|Fast
    algorithms for common operations: division, gcd, multi-point evaluation,
    etc.|<point|0|1>>>|<with|fill-color|pastel
    yellow|<cline|<point|-10.6667|-1.33333>|<point|10.6666666666667|-1.33333333333333>|<point|10.6666666666667|-2.66666666666667>|<point|-10.6666666666667|-2.66666666666667>>>|<with|text-at-valign|center|text-at-halign|center|<text-at|Fast
    multiplication in other algebras such as
    <math|\<bbb-K\><around*|[|<around*|[|x|]>|]>>,
    <math|\<bbb-K\><around*|[|x,\<partial\>/\<partial\> x|]>> or
    <math|\<bbb-K\><around*|[|x<rsub|1>,\<ldots\>,x<rsub|n>|]>>|<point|0|-2>>>|<with|fill-color|pastel
    yellow|<cline|<point|-10.6667|-4.33333>|<point|10.6666666666667|-4.33333333333333>|<point|10.6666666666667|-5.66666666666667>|<point|-10.6666666666667|-5.66666666666667>>>|<with|text-at-valign|center|text-at-halign|center|<text-at|Fast
    multiplication in <math|\<bbb-Z\>>, <math|\<bbb-K\><around*|[|x|]>> and
    <math|\<bbb-K\><rsup|n\<times\>n>>|<point|0|-5>>>|<with|arrow-end|\<gtr\>|<line|<point|-4|-2.66667>|<point|-4.0|-4.33333104167025>>>|<with|arrow-end|\<gtr\>|<line|<point|0|-2.66667>|<point|0.0|-4.33333333333333>>>|<with|arrow-end|\<gtr\>|<line|<point|4|-2.66667>|<point|4.0|-4.33333333333333>>>|<with|arrow-end|\<gtr\>|<line|<point|-4|0.333333>|<point|-4.0|-1.33333333333333>>>|<with|arrow-end|\<gtr\>|<line|<point|0|0.333333>|<point|0.0|-1.33333333333333>>>|<with|arrow-end|\<gtr\>|<line|<point|4|0.333333>|<point|4.0|-1.33333333333333>>>|<with|arrow-end|\<gtr\>|<line|<point|-4|3.33333>|<point|-4.0|1.66666666666667>>>|<with|arrow-end|\<gtr\>|<line|<point|0|3.33333>|<point|0.0|1.66666666666667>>>|<with|arrow-end|\<gtr\>|<line|<point|4|3.33333>|<point|4.0|1.66666666666667>>>>>
  </hidden>|<\hidden>
    <tit|Layer I \V fundamental complexities>

    \;

    \;

    <htab|5mm><flat-size|<block|<tformat|<cwith|1|-1|1|-1|cell-bsep|0.666spc>|<cwith|1|-1|1|-1|cell-tsep|0.666spc>|<cwith|5|5|1|4|cell-bsep|0.666spc>|<cwith|5|5|1|4|cell-tsep|0.666spc>|<cwith|1|1|1|-1|cell-background|<pattern|ice-dark-blue.png||>>|<cwith|1|1|1|-1|color|white>|<table|<row|<cell|Algebra>|<cell|Model>|<cell|Current
    record>|<cell|Author(s)>>|<row|<cell|<math|\<bbb-Z\>>>|<cell|binary>|<cell|<math|<math-ss|I><around*|(|n|)>=O<around*|(|n*log
    n*8<rsup|log<rsup|\<ast\>> n>|)>>>|<cell|Harvey-vdH-Lecerf
    2014>>|<row|<cell|<math|\<bbb-K\><around*|[|z|]>>>|<cell|algebraic>|<cell|<math|<math-ss|M><around*|(|d|)>=O<around*|(|d*log
    d*log log d|)>>>|<cell|Cantor-Kaltofen
    1981>>|<row|<cell|<math|\<bbb-F\><rsub|p><around*|[|z|]>>>|<cell|binary>|<cell|<math|<stack|<tformat|<cwith|2|2|1|1|cell-halign|l>|<table|<row|<cell|O<around*|(|t*log
    t*8<rsup|log<rsup|\<ast\>> t>|)>>>|<row|<cell|t=d*log
    p>>>>>>>|<cell|Harvey-vdH-Lecerf 2014>>|<row|<cell|<math|\<bbb-K\><around*|[|z|]>>>|<cell|<stack|<tformat|<cwith|2|2|1|1|cell-halign|l>|<table|<row|<cell|algebraic>>|<row|<cell|<abbr|char.>
    <math|p\<gtr\>0>>>>>>>|<cell|<math|<math-ss|M><around*|(|d|)>=O<around*|(|d*log
    d*8<rsup|log<rsup|\<ast\>> d>|)>>>|<cell|Harvey-vdH-Lecerf
    2014>>|<row|<cell|<math|\<bbb-K\><rsup|r\<times\>r>>>|<cell|algebraic>|<cell|<math|O<around*|(|n<rsup|\<omega\>>|)>>,
    <math|\<omega\>\<leqslant\>2.3728639>>|<cell|Le Gall 2014>>>>>><htab|5mm>

    \;

    <\eqnarray*>
      <tformat|<table|<row|<cell|log<rsup|\<ast\>>
      x>|<cell|\<assign\>>|<cell|min <around*|{|k\<in\>\<bbb-N\>:log<rsup|\<circ\>k>
      x\<leqslant\>1|}>,>>|<row|<cell|<op|log<rsup|\<circ\>k>>>|<cell|\<assign\>>|<cell|<op|log>\<circ\><below|\<cdots\>|k\<times\>>\<circ\><op|log>.>>>>
    </eqnarray*>
  </hidden>|<\hidden>
    <tit|Layer II \V fast multiplication in several algebras>

    \;

    <htab|5mm><flat-size|<block|<tformat|<cwith|1|-1|1|-1|cell-bsep|0.666spc>|<cwith|1|-1|1|-1|cell-tsep|0.666spc>|<cwith|1|1|1|4|cell-bsep|0.666spc>|<cwith|1|1|1|4|cell-tsep|0.666spc>|<cwith|1|1|1|4|cell-background|<pattern|ice-dark-blue.png||>>|<cwith|1|1|1|4|color|white>|<cwith|2|-1|1|-1|cell-bsep|1spc>|<cwith|2|-1|1|-1|cell-tsep|1spc>|<table|<row|<cell|Algebra>|<cell|Model>|<cell|Current
    record>|<cell|Author(s)>>|<row|<cell|<math|\<bbb-K\><around*|[|x|]><rsup|r\<times\>r>>>|<cell|algebraic>|<cell|<math|O<around*|(|<math-ss|M><around*|(|d|)>*r<rsup|2>+d*r<rsup|\<omega\>>|)>>>|<cell|Bostan-Schost
    2005>>|<row|<cell|<math|\<bbb-Z\><rsup|r\<times\>r>>>|<cell|binary>|<cell|<math|O<around*|(|<space|-0.6spc>r<rsup|2>*<math-ss|M><around*|(|n|)><space|-0.2spc>+<space|-0.4spc>r<rsup|\<omega\>>*<space|-0.4spc>n*<space|-0.4spc>2<rsup|log<rsup|\<ast\>>
    n-log<rsup|\<ast\>> d>*<frac|<math-ss|M><around*|(|log r|)>|log
    r><space|-0.4spc>|)>>>|<cell|Harvey-vdH
    2014>>|<row|<cell|<math|\<bbb-K\><around*|[|<around*|[|z|]>|]>>>|<cell|<stack|<tformat|<cwith|2|2|1|1|cell-halign|l>|<table|<row|<cell|algebraic>>|<row|<cell|relaxed>>>>>>|<cell|<math|<stack|<tformat|<cwith|2|2|1|1|cell-halign|l>|<cwith|1|1|1|1|cell-halign|l>|<table|<row|<cell|O<around*|(|d*log
    d*\<mathe\><rsup|<sqrt|2*log 2>*<sqrt|log log
    d>>*X|)>>>|<row|<cell|X=<around*|(|log log d|)><rsup|5/2>*log log log
    d>>>>>>>|<cell|vdH 2014>>|<row|<cell|<math|\<bbb-Z\><rsub|p>>>|<cell|<stack|<tformat|<cwith|1|1|1|1|cell-halign|l>|<table|<row|<cell|binary>>|<row|<cell|relaxed>>>>>>|<cell|<math|<stack|<tformat|<cwith|2|2|1|1|cell-halign|l>|<cwith|3|3|1|1|cell-halign|l>|<cwith|1|1|1|1|cell-halign|l>|<table|<row|<cell|O<around*|(|d*log
    d*\<mathe\><rsup|<sqrt|2*log 2>*<sqrt|log log
    d>>*X|)>>>|<row|<cell|X=<around*|(|<around*|(|log log d|)><rsup|3/2>*log
    p|)>*\<ell\>*log \<ell\>>>|<row|<cell|\<ell\>=log <around*|(|log d+log
    p|)>>>>>>>>|<cell|<tabular|<tformat|<cwith|1|-1|1|1|cell-lsep|0spc>|<cwith|1|-1|1|1|cell-rsep|0spc>|<table|<row|<cell|vdH
    2014>>|<row|<cell|Bertomieu-vdH-Lecerf
    2011>>>>>>>|<row|<cell|<math|\<bbb-K\><around*|[|z<rsub|1>,\<ldots\>,z<rsub|k>|]>>>|<cell|<stack|<tformat|<cwith|1|1|1|1|cell-halign|l>|<cwith|2|2|1|1|cell-halign|l>|<table|<row|<cell|algebraic>>|<row|<cell|dense>>>>>>|<cell|<math|O<around*|(|<math-ss|M><around*|(|s|)>|)>>>|<cell|vdH-Schost
    2010>>|<row|<cell|<math|\<bbb-Z\><around*|[|z<rsub|1>,\<ldots\>,z<rsub|k>|]>>>|<cell|<stack|<tformat|<cwith|1|1|1|1|cell-halign|l>|<cwith|2|2|1|1|cell-halign|l>|<table|<row|<cell|binary>>|<row|<cell|sparse>>>>>>|<cell|<math|<stack|<tformat|<cwith|2|2|1|1|cell-halign|l>|<table|<row|<cell|O<around*|(|<math-ss|I><around*|(|s*\<nu\>|)>*log
    s+s*<math-ss|I><around*|(|\<nu\>|)>*log
    \<nu\>|)>>>|<row|<cell|\<nu\>=n+k*log d>>>>>>>|<cell|vdH-Lecerf
    2009>>|<row|<cell|<math|\<bbb-K\><around*|[|z,\<partial\>|]>>>|<cell|algebraic>|<cell|<stack|<tformat|<cwith|1|1|1|1|cell-halign|l>|<cwith|2|2|1|1|cell-halign|l>|<table|<row|<cell|<math|O<around*|(|r<rsup|\<omega\>-1>*d+r*<math-ss|M><around*|(|d|)>*log
    d|)>> si <math|d\<geqslant\>r>>>|<row|<cell|<math|O<around*|(|d<rsup|\<omega\>-1>*r+d*<math-ss|M><around*|(|r|)>*log
    r|)>> si <math|r\<geqslant\>d>>>>>>>|<cell|Benoit-Bostan-vdH
    20<space|-0.2spc>1<space|-0.2spc>2>>>>>><htab|5mm>
  </hidden>|<\hidden>
    <tit|Layer III \V other common operations>

    \;

    \;

    \;

    <htab|5mm><flat-size|<block|<tformat|<cwith|1|-1|1|-1|cell-bsep|0.666spc>|<cwith|1|-1|1|-1|cell-tsep|0.666spc>|<cwith|1|1|1|4|cell-bsep|0.666spc>|<cwith|1|1|1|4|cell-tsep|0.666spc>|<cwith|1|1|1|4|cell-background|<pattern|ice-dark-blue.png||>>|<cwith|1|1|1|4|color|white>|<cwith|2|-1|1|-1|cell-bsep|1spc>|<cwith|2|-1|1|-1|cell-tsep|1spc>|<cwith|6|6|1|4|cell-bsep|0.666spc>|<cwith|6|6|1|4|cell-tsep|0.666spc>|<cwith|6|6|1|4|cell-bsep|1spc>|<cwith|6|6|1|4|cell-tsep|1spc>|<cwith|3|3|1|4|cell-bsep|0.666spc>|<cwith|3|3|1|4|cell-tsep|0.666spc>|<cwith|3|3|1|4|cell-bsep|1spc>|<cwith|3|3|1|4|cell-tsep|1spc>|<table|<row|<cell|Operation>|<cell|Model>|<cell|Current
    record>|<cell|Author(s)>>|<row|<cell|Euclidean division in
    <math|\<bbb-Z\>>>|<cell|binary>|<cell|<math|\<lesssim\><space|0.6spc><frac*|5|3>*<math-ss|I><around*|(|n|)>>>|<cell|vdH
    2010<rsup|*>>>|<row|<cell|Square root in
    <math|\<bbb-Z\>>>|<cell|binary>|<cell|<math|\<lesssim\><space|0.6spc><frac*|4|3>*<math-ss|I><around*|(|n|)>>>|<cell|<tabular|<tformat|<cwith|1|-1|1|1|cell-lsep|0spc>|<cwith|1|-1|1|1|cell-rsep|0spc>|<table|<row|<cell|Harvey
    2009<rsup|*>>>|<row|<cell|vdH>>>>>>>|<row|<cell|<abbr|G.c.d.> in
    <math|\<bbb-Z\>>>|<cell|binary>|<cell|<math|O<around*|(|<math-ss|I><around*|(|n|)>*log
    n<space|-0.4spc>|)>>>|<cell|<tabular|<tformat|<cwith|1|-1|1|1|cell-lsep|0spc>|<cwith|1|-1|1|1|cell-rsep|0spc>|<table|<row|<cell|Schnhage
    1971>>|<row|<cell|Lehmer>>>>>>>|<row|<cell|Chinese
    remaindering>|<cell|binary>|<cell|<math|O<around*|(|<math-ss|I><around*|(|n*d|)>*log
    d|)>>>|<cell|Borodin-Moenck 1972>>|<row|<cell|<tabular|<tformat|<cwith|1|-1|1|1|cell-lsep|0spc>|<cwith|1|-1|1|1|cell-rsep|0spc>|<table|<row|<cell|Chinese
    remaindering>>|<row|<cell|Fixed moduli>>>>>>|<cell|binary>|<cell|<math|O<around*|(|<math-ss|I><around*|(|n*d|)>*<frac|log
    d|log log <around*|(|n*d|)>>|)>>>|<cell|vdH 2016>>>>>><htab|5mm>

    \;

    <htab|5mm><small|* Adapted from power series analogue><htab|5mm>
  </hidden>|<\hidden>
    <tit|Integer multiplication, very short history>

    \;

    \;

    <htab|5mm><block|<tformat|<cwith|1|-1|1|-1|cell-tsep|0.5spc>|<cwith|1|-1|1|-1|cell-bsep|0.5spc>|<cwith|6|6|1|3|cell-tsep|0.5spc>|<cwith|6|6|1|3|cell-bsep|0.5spc>|<cwith|1|1|1|-1|cell-background|<pattern|/Users/vdhoeven/texmacs/src/TeXmacs/misc/patterns/ice-dark-blue.png||>>|<table|<row|<cell|<with|color|white|Date>>|<cell|<with|color|white|Authors>>|<cell|<with|color|white|Complexity>>>|<row|<cell|<math|\<less\>>3000
    aJC>|<cell|Unknown>|<cell|<math|O<around*|(|n<rsup|2>|)>>>>|<row|<cell|1962>|<cell|Karatsuba>|<cell|<math|O<around|(|n<rsup|log
    3/log 2>|)>>>>|<row|<cell|1963 <greyed|(1965)>>|<cell|Toom
    <greyed|(Cook)>>|<cell|<math|O<around|(|<with|font-shape|italic|n*>2<rsup|5*<sqrt|log
    n/log 2>>|)>>>>|<row|<cell|1966>|<cell|Schnhage>|<cell|<math|O<around|(|n*2<rsup|<sqrt|2*log
    n/log 2>>*<around*|(|log n|)><rsup|3/2>|)>>>>|<row|<cell|1969>|<cell|Knuth>|<cell|<math|O<around|(|n*2<rsup|<sqrt|2*log
    n/log 2>>*log n|)>>>>|<row|<cell|1971>|<cell|Schnhage\UStrassen>|<cell|<math|O<around*|(|n*log
    n*log log n|)>>>>|<row|<cell|2007>|<cell|Frer>|<cell|<math|O<around*|(|n*log
    n*2<rsup|O<around*|(|log<rsup|\<ast\>>
    n|)>>|)>>>>|<row|<cell|2014>|<cell|Harvey\UvdH\ULecerf>|<cell|<math|O<around*|(|n*log
    n*8<rsup|log<rsup|\<ast\>> n>|)>>>>>>><htab|5mm>

    \;
  </hidden>|<\hidden>
    <tit|Kronecker>

    \;

    From integers to polynomials and back

    <\eqnarray*>
      <tformat|<table|<row|<cell|971362<with|color|dark
      green|651726>262537<with|color|dark
      green|182735>>|<cell|=>|<cell|971362*X<rsup|3>+<with|color|dark
      green|651726>*X<rsup|2>+262537*X+<with|color|dark
      green|182735>>>|<row|<cell|X>|<cell|=>|<cell|1000000>>>>
    </eqnarray*>
  </hidden>|<\hidden>
    <tit|Karatsuba>

    <\equation*>
      <tabular*|<tformat|<table|<row|<cell|p=127622<with|color|dark
      green|142187>>|<cell|>|<cell|q=209836<with|color|dark
      green|129877>>>|<row|<cell|>|<cell|>|<cell|>>|<row|<cell|P=127622*X+<with|color|dark
      green|142187>>|<cell|>|<cell|Q=209836*X+<with|color|dark
      green|129877>>>>>>
    </equation*>

    <switch|<\shown>
      <switch|<\shown>
        <\wide-tabular>
          <tformat|<cwith|1|1|2|2|cell-valign|t>|<table|<row|<\cell>
            <block|<tformat|<cwith|1|2|2|-1|cell-height|3cm>|<cwith|1|2|2|-1|cell-vmode|exact>|<cwith|1|-1|1|-1|cell-halign|c>|<cwith|1|-1|1|-1|cell-valign|c>|<table|<row|<cell|<math|Q<rsub|1>=209836>>|<cell|<math|<with|color|dark
            blue|P<rsub|0>*Q<rsub|1>>>>|<cell|<math|P<rsub|1>*Q<rsub|1>>>>|<row|<cell|<math|<with|color|dark
            green|Q<rsub|0>=129877>>>|<cell|<math|<with|color|dark
            green|P<rsub|0>*Q<rsub|0>>>>|<cell|<math|<with|color|dark
            blue|P<rsub|1>*Q<rsub|0>>>>>|<row|<cell|>|<cell|<math|<with|color|dark
            green|P<rsub|0>=142187>>>|<cell|<math|P<rsub|1>=127622>>>>>>
          </cell>|<\cell>
            \;
          </cell>>>>
        </wide-tabular>
      </shown>|<\hidden>
        <\wide-tabular>
          <tformat|<cwith|1|1|2|2|cell-valign|t>|<table|<row|<\cell>
            <block|<tformat|<cwith|1|2|2|-1|cell-height|3cm>|<cwith|1|2|2|-1|cell-vmode|exact>|<cwith|1|-1|1|-1|cell-halign|c>|<cwith|1|-1|1|-1|cell-valign|c>|<cwith|2|2|2|2|cell-background|pastel
            green>|<table|<row|<cell|<math|Q<rsub|1>=209836>>|<cell|<math|<with|color|dark
            blue|P<rsub|0>*Q<rsub|1>>>>|<cell|<math|P<rsub|1>*Q<rsub|1>>>>|<row|<cell|<math|<with|color|dark
            green|Q<rsub|0>=129877>>>|<cell|<math|<with|color|dark
            green|P<rsub|0>*Q<rsub|0>>>>|<cell|<math|<with|color|dark
            blue|P<rsub|1>*Q<rsub|0>>>>>|<row|<cell|>|<cell|<math|<with|color|dark
            green|P<rsub|0>=142187>>>|<cell|<math|P<rsub|1>=127622>>>>>>
          </cell>|<\cell>
            <\eqnarray*>
              <tformat|<table|<row|<cell|<with|color|dark
              green|P<rsub|0>*Q<rsub|0>>>|<cell|<with|color|dark
              green|=>>|<cell|<with|color|dark green|18466820999>>>>>
            </eqnarray*>
          </cell>>>>
        </wide-tabular>
      </hidden>|<\hidden>
        <\wide-tabular>
          <tformat|<cwith|1|1|2|2|cell-valign|t>|<table|<row|<\cell>
            <block|<tformat|<cwith|1|2|2|-1|cell-height|3cm>|<cwith|1|2|2|-1|cell-vmode|exact>|<cwith|1|-1|1|-1|cell-halign|c>|<cwith|1|-1|1|-1|cell-valign|c>|<cwith|2|2|2|2|cell-background|pastel
            green>|<cwith|1|1|3|3|cell-background|pastel
            brown>|<table|<row|<cell|<math|Q<rsub|1>=209836>>|<cell|<math|<with|color|dark
            blue|P<rsub|0>*Q<rsub|1>>>>|<cell|<math|P<rsub|1>*Q<rsub|1>>>>|<row|<cell|<math|<with|color|dark
            green|Q<rsub|0>=129877>>>|<cell|<math|<with|color|dark
            green|P<rsub|0>*Q<rsub|0>>>>|<cell|<math|<with|color|dark
            blue|P<rsub|1>*Q<rsub|0>>>>>|<row|<cell|>|<cell|<math|<with|color|dark
            green|P<rsub|0>=142187>>>|<cell|<math|P<rsub|1>=127622>>>>>>
          </cell>|<\cell>
            <\eqnarray*>
              <tformat|<table|<row|<cell|<with|color|dark
              green|P<rsub|0>*Q<rsub|0>>>|<cell|<with|color|dark
              green|=>>|<cell|<with|color|dark
              green|18466820999>>>|<row|<cell|P<rsub|1>*Q<rsub|1>>|<cell|=>|<cell|26779689992>>>>
            </eqnarray*>
          </cell>>>>
        </wide-tabular>
      </hidden>|<\hidden>
        <\wide-tabular>
          <tformat|<cwith|1|1|2|2|cell-valign|t>|<table|<row|<\cell>
            <block|<tformat|<cwith|1|2|2|-1|cell-height|3cm>|<cwith|1|2|2|-1|cell-vmode|exact>|<cwith|1|-1|1|-1|cell-halign|c>|<cwith|1|-1|1|-1|cell-valign|c>|<cwith|1|2|2|-1|cell-background|pastel
            magenta>|<table|<row|<cell|<math|Q<rsub|1>=209836>>|<cell|<math|<with|color|dark
            blue|P<rsub|0>*Q<rsub|1>>>>|<cell|<math|P<rsub|1>*Q<rsub|1>>>>|<row|<cell|<math|<with|color|dark
            green|Q<rsub|0>=129877>>>|<cell|<math|<with|color|dark
            green|P<rsub|0>*Q<rsub|0>>>>|<cell|<math|<with|color|dark
            blue|P<rsub|1>*Q<rsub|0>>>>>|<row|<cell|>|<cell|<math|<with|color|dark
            green|P<rsub|0>=142187>>>|<cell|<math|P<rsub|1>=127622>>>>>>
          </cell>|<\cell>
            <\eqnarray*>
              <tformat|<table|<row|<cell|<with|color|dark
              green|P<rsub|0>*Q<rsub|0>>>|<cell|<with|color|dark
              green|=>>|<cell|<with|color|dark
              green|18466820999>>>|<row|<cell|P<rsub|1>*Q<rsub|1>>|<cell|=>|<cell|26779689992>>|<row|<cell|<with|color|dark
              magenta|<around*|(|P<rsub|0>+P<rsub|1>|)>*<around*|(|Q<rsub|0>+Q<rsub|1>|)>>>|<cell|<with|color|dark
              magenta|=>>|<cell|<with|color|dark magenta|91657624817>>>>>
            </eqnarray*>
          </cell>>>>
        </wide-tabular>
      </hidden>|<\hidden>
        <\wide-tabular>
          <tformat|<cwith|1|1|2|2|cell-valign|t>|<table|<row|<\cell>
            <block|<tformat|<cwith|1|2|2|-1|cell-height|3cm>|<cwith|1|2|2|-1|cell-vmode|exact>|<cwith|1|-1|1|-1|cell-halign|c>|<cwith|1|-1|1|-1|cell-valign|c>|<cwith|1|2|2|-1|cell-background|pastel
            magenta>|<cwith|2|2|2|2|cell-background|>|<table|<row|<cell|<math|Q<rsub|1>=209836>>|<cell|<math|<with|color|dark
            blue|P<rsub|0>*Q<rsub|1>>>>|<cell|<math|P<rsub|1>*Q<rsub|1>>>>|<row|<cell|<math|<with|color|dark
            green|Q<rsub|0>=129877>>>|<cell|<math|<with|color|dark
            green|P<rsub|0>*Q<rsub|0>>>>|<cell|<math|<with|color|dark
            blue|P<rsub|1>*Q<rsub|0>>>>>|<row|<cell|>|<cell|<math|<with|color|dark
            green|P<rsub|0>=142187>>>|<cell|<math|P<rsub|1>=127622>>>>>>
          </cell>|<\cell>
            <\eqnarray*>
              <tformat|<table|<row|<cell|<with|color|dark
              green|P<rsub|0>*Q<rsub|0>>>|<cell|<with|color|dark
              green|=>>|<cell|<with|color|dark
              green|18466820999>>>|<row|<cell|P<rsub|1>*Q<rsub|1>>|<cell|=>|<cell|26779689992>>|<row|<cell|A=<with|color|dark
              magenta|<around*|(|P<rsub|0>+P<rsub|1>|)>*<around*|(|Q<rsub|0>+Q<rsub|1>|)>>>|<cell|<with|color|dark
              magenta|=>>|<cell|<with|color|dark
              magenta|91657624817>>>|<row|<cell|>|<cell|>|<cell|>>|<row|<cell|A-P<rsub|0>*Q<rsub|0>>|<cell|>|<cell|>>>>
            </eqnarray*>
          </cell>>>>
        </wide-tabular>
      </hidden>|<\hidden>
        <\wide-tabular>
          <tformat|<cwith|1|1|2|2|cell-valign|t>|<table|<row|<\cell>
            <block|<tformat|<cwith|1|2|2|-1|cell-height|3cm>|<cwith|1|2|2|-1|cell-vmode|exact>|<cwith|1|-1|1|-1|cell-halign|c>|<cwith|1|-1|1|-1|cell-valign|c>|<cwith|1|2|2|-1|cell-background|pastel
            magenta>|<cwith|2|2|2|2|cell-background|>|<cwith|1|1|3|3|cell-background|>|<table|<row|<cell|<math|Q<rsub|1>=209836>>|<cell|<math|<with|color|dark
            blue|P<rsub|0>*Q<rsub|1>>>>|<cell|<math|P<rsub|1>*Q<rsub|1>>>>|<row|<cell|<math|<with|color|dark
            green|Q<rsub|0>=129877>>>|<cell|<math|<with|color|dark
            green|P<rsub|0>*Q<rsub|0>>>>|<cell|<math|<with|color|dark
            blue|P<rsub|1>*Q<rsub|0>>>>>|<row|<cell|>|<cell|<math|<with|color|dark
            green|P<rsub|0>=142187>>>|<cell|<math|P<rsub|1>=127622>>>>>>
          </cell>|<\cell>
            <\eqnarray*>
              <tformat|<table|<row|<cell|<with|color|dark
              green|P<rsub|0>*Q<rsub|0>>>|<cell|<with|color|dark
              green|=>>|<cell|<with|color|dark
              green|18466820999>>>|<row|<cell|P<rsub|1>*Q<rsub|1>>|<cell|=>|<cell|26779689992>>|<row|<cell|<with|color|dark
              magenta|A=<around*|(|P<rsub|0>+P<rsub|1>|)>*<around*|(|Q<rsub|0>+Q<rsub|1>|)>>>|<cell|<with|color|dark
              magenta|=>>|<cell|<with|color|dark
              magenta|91657624817>>>|<row|<cell|>|<cell|>|<cell|>>|<row|<cell|<with|color|dark
              magenta|A>-<with|color|dark
              green|P<rsub|0>*Q<rsub|0>>-P<rsub|1>*Q<rsub|1>>|<cell|>|<cell|>>>>
            </eqnarray*>
          </cell>>>>
        </wide-tabular>
      </hidden>|<\hidden>
        <\wide-tabular>
          <tformat|<cwith|1|1|2|2|cell-valign|t>|<table|<row|<\cell>
            <block|<tformat|<cwith|1|2|2|-1|cell-height|3cm>|<cwith|1|2|2|-1|cell-vmode|exact>|<cwith|1|-1|1|-1|cell-halign|c>|<cwith|1|-1|1|-1|cell-valign|c>|<cwith|1|2|2|-1|cell-background|pastel
            blue>|<cwith|2|2|2|2|cell-background|pastel
            green>|<cwith|1|1|3|3|cell-background|pastel
            brown>|<table|<row|<cell|<math|Q<rsub|1>=209836>>|<cell|<math|<with|color|dark
            blue|P<rsub|0>*Q<rsub|1>>>>|<cell|<math|P<rsub|1>*Q<rsub|1>>>>|<row|<cell|<math|<with|color|dark
            green|Q<rsub|0>=129877>>>|<cell|<math|<with|color|dark
            green|P<rsub|0>*Q<rsub|0>>>>|<cell|<math|<with|color|dark
            blue|P<rsub|1>*Q<rsub|0>>>>>|<row|<cell|>|<cell|<math|<with|color|dark
            green|P<rsub|0>=142187>>>|<cell|<math|P<rsub|1>=127622>>>>>>
          </cell>|<\cell>
            <\eqnarray*>
              <tformat|<table|<row|<cell|<with|color|dark
              green|P<rsub|0>*Q<rsub|0>>>|<cell|<with|color|dark
              green|=>>|<cell|<with|color|dark
              green|18466820999>>>|<row|<cell|P<rsub|1>*Q<rsub|1>>|<cell|=>|<cell|26779689992>>|<row|<cell|<with|color|dark
              magenta|A=<around*|(|P<rsub|0>+P<rsub|1>|)>*<around*|(|Q<rsub|0>+Q<rsub|1>|)>>>|<cell|<with|color|dark
              magenta|=>>|<cell|<with|color|dark
              magenta|91657624817>>>|<row|<cell|>|<cell|>|<cell|>>|<row|<cell|<with|color|dark
              magenta|A>-<with|color|dark
              green|P<rsub|0>*Q<rsub|0>>-P<rsub|1>*Q<rsub|1>>|<cell|<with|color|dark
              blue|=>>|<cell|<with|color|dark
              blue|P<rsub|0>*Q<rsub|1>+P<rsub|1>*Q<rsub|0>>>>|<row|<cell|>|<cell|<with|color|dark
              blue|=>>|<cell|<with|color|dark blue|46411113826>>>>>
            </eqnarray*>
          </cell>>>>
        </wide-tabular>
      </hidden>>

      <\equation*>
        <tabular*|<tformat|<table|<row|<cell|>|<cell|P*Q=P<rsub|0>*Q<rsub|0>+<with|color|dark
        blue|<around*|(|P<rsub|0>*Q<rsub|1>+P<rsub|1>*Q<rsub|0>|)>>*X+<with|color|dark
        green|P<rsub|1>*Q<rsub|1>>*X<rsup|2>>>>>>
      </equation*>
    </shown>|<\hidden>
      <\wide-tabular>
        <tformat|<cwith|1|1|2|2|cell-valign|t>|<table|<row|<\cell>
          <block|<tformat|<cwith|1|2|2|-1|cell-height|3cm>|<cwith|1|2|2|-1|cell-vmode|exact>|<cwith|1|-1|1|-1|cell-halign|c>|<cwith|1|-1|1|-1|cell-valign|c>|<cwith|1|2|2|-1|cell-background|pastel
          blue>|<cwith|2|2|2|2|cell-background|pastel
          green>|<cwith|1|1|3|3|cell-background|pastel
          brown>|<table|<row|<cell|<math|Q<rsub|1>=209836>>|<cell|<math|<with|color|dark
          blue|P<rsub|0>*Q<rsub|1>>>>|<cell|<math|P<rsub|1>*Q<rsub|1>>>>|<row|<cell|<math|<with|color|dark
          green|Q<rsub|0>=129877>>>|<cell|<math|<with|color|dark
          green|P<rsub|0>*Q<rsub|0>>>>|<cell|<math|<with|color|dark
          blue|P<rsub|1>*Q<rsub|0>>>>>|<row|<cell|>|<cell|<math|<with|color|dark
          green|P<rsub|0>=142187>>>|<cell|<math|P<rsub|1>=127622>>>>>>
        </cell>|<\cell>
          <\eqnarray*>
            <tformat|<table|<row|<cell|<with|color|dark
            green|P<rsub|0>*Q<rsub|0>>>|<cell|<with|color|dark
            green|=>>|<cell|<with|color|dark
            green|18466820999>>>|<row|<cell|P<rsub|1>*Q<rsub|1>>|<cell|=>|<cell|26779689992>>|<row|<cell|<with|color|dark
            magenta|A=<around*|(|P<rsub|0>+P<rsub|1>|)>*<around*|(|Q<rsub|0>+Q<rsub|1>|)>>>|<cell|<with|color|dark
            magenta|=>>|<cell|<with|color|dark
            magenta|91657624817>>>|<row|<cell|>|<cell|>|<cell|>>|<row|<cell|<with|color|dark
            magenta|A>-<with|color|dark green|P<rsub|0>*Q<rsub|0>>-P<rsub|1>*Q<rsub|1>>|<cell|<with|color|dark
            blue|=>>|<cell|<with|color|dark
            blue|P<rsub|0>*Q<rsub|1>+P<rsub|1>*Q<rsub|0>>>>|<row|<cell|>|<cell|<with|color|dark
            blue|=>>|<cell|<with|color|dark blue|46411113826>>>>>
          </eqnarray*>
        </cell>>>>
      </wide-tabular>

      <switch|<\shown>
        <\equation*>
          <tabular*|<tformat|<table|<row|<cell|>|<cell|<resize|P*Q=26779689992+<with|color|dark
          blue|46411113826>*X+<with|color|dark
          green|18466820999>*X<rsup|2>|<plus|1l|3cm>||<plus|1r|-3cm>|>>|<cell|>>>>>
        </equation*>
      </shown>|<\hidden>
        <\equation*>
          <tabular*|<tformat|<table|<row|<cell|>|<cell|<resize|P*Q=26779689992+<with|color|dark
          blue|46411113826>*X+<with|color|dark
          green|18466820999>*X<rsup|2>|<plus|1l|3cm>||<plus|1r|-3cm>|>>|<cell|>>|<row|<cell|>|<cell|>|<cell|>>|<row|<cell|p*q=>|<cell|<tabular|<tformat|<cwith|3|3|1|1|cell-bborder|1ln>|<table|<row|<cell|26779689992<greyed|000000000000>>>|<row|<cell|<with|color|dark
          blue|<greyed|000000>46411113826<greyed|000000>>>>|<row|<cell|<with|color|dark
          green|<greyed|000000000000>18466820999>>>|<row|<cell|26779736403132292820999>>>>>>|<cell|>>>>>
        </equation*>
      </hidden>>
    </hidden>>
  </hidden>|<\hidden>
    <tit|Multiplication by evaluation-interpolation>

    <unroll|<\shown>
      <strong|Karatsuba>

      <\eqnarray*>
        <tformat|<cwith|2|2|3|3|cell-bsep|2spc>|<cwith|3|3|1|-1|color|dark
        green>|<cwith|5|5|1|-1|color|dark
        magenta>|<table|<row|<cell|P>|<cell|=>|<cell|127622*X+<with|color|dark
        green|142187>>>|<row|<cell|Q>|<cell|=>|<cell|209836*X+<with|color|dark
        green|129877>>>|<row|<cell|P<rsub|0>*Q<rsub|0>>|<cell|=>|<cell|<around*|(|P*Q|)><around*|(|0|)><space|1.6spc>=P<around*|(|0|)>*Q<around*|(|0|)>>>|<row|<cell|P<rsub|1>*Q<rsub|1>*\<infty\><rsup|2>>|<cell|=>|<cell|<around*|(|P*Q|)><around*|(|\<infty\>|)>=P<around*|(|\<infty\>|)>*Q<around*|(|\<infty\>|)>>>|<row|<cell|<around*|(|P<rsub|0>+P<rsub|1>|)>*<around*|(|Q<rsub|0>+Q<rsub|1>|)>>|<cell|=>|<cell|<around*|(|P*Q|)><around*|(|1|)><space|1.6spc>=P<around*|(|1|)>*Q<around*|(|1|)>>>>>
      </eqnarray*>
    </shown>|<\hidden*>
      <strong|Evaluation-interpolation>

      <with|gr-mode|<tuple|edit|text-at>|gr-frame|<tuple|scale|1cm|<tuple|0.430004gw|0.499999gh>>|gr-geometry|<tuple|geometry|1par|0.317374par|center>|gr-transformation|<tuple|<tuple|1.0|0.0|0.0|0.0>|<tuple|0.0|-0.987479769908862|-0.157745694143246|0.0>|<tuple|0.0|0.157745694143246|-0.987479769908862|0.0>|<tuple|0.0|0.0|0.0|1.0>>|gr-arrow-end|\<gtr\>|gr-dash-style|11100|gr-text-at-halign|center|<graphics||<with|text-at-valign|center|text-at-halign|center|<math-at|P<around*|(|x<rsub|0>|)>,\<ldots\>,P<around*|(|x<rsub|N-1>|)>|<point|-2|-1>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|Q<around*|(|x<rsub|0>|)>,\<ldots\>,Q<around*|(|x<rsub|N-1>|)>|<point|-2|-2>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|P*Q|<point|5.5|2.0>>>|<with|arrow-end|\<gtr\>|<line|<point|-2.0|1.5>|<point|-2.00937624024342|-0.712792697446752>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|P,Q\<in\>\<bbb-K\><around*|[|X|]>|<point|-2.0|2.0>>>|<with|arrow-end|\<gtr\>|<line|<point|0.294284958327821|-1.50029765842043>|<point|2.26891784627596|-1.5>>>|<with|arrow-end|\<gtr\>|<line|<point|5.5|-0.75>|<point|5.5|1.53695925386956>>>|<with|arrow-end|\<gtr\>|dash-style|11100|<line|<point|0.25|2>|<point|4.82064426511443|2.0>>>|<with|text-at-valign|center|text-at-halign|right|<text-at|Evaluation|<point|-2.5|0.5>>>|<with|text-at-valign|center|<text-at|Interpolation|<point|6|0.5>>>|<with|text-at-halign|center|<text-at|Multiplication|<point|2.5|2.5>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|<around*|(|P*Q|)><around*|(|x<rsub|0>|)>,\<ldots\>,<around*|(|P*Q|)><around*|(|x<rsub|N-1>|)>|<point|5.8024209551528|-1.47479825373727>>>|<with|text-at-halign|center|<text-at|Pointwise
      multiplication|<point|1.71636459849186|-3.22283040084667>>>>>
    </hidden*>>
  </hidden>|<\hidden>
    <tit|Cyclic convolutions using discrete Fourier transforms>

    <unroll|<\shown>
      <strong|Discrete Fourier transforms>

      <\compact>
        Assume that <math|\<omega\>\<in\>\<bbb-K\>> is such that
        <math|\<omega\><rsup|N>=1>, <math|N\<in\>2<rsup|\<bbb-N\>>> and
        <math|1,\<omega\>,\<omega\><rsup|2>,\<ldots\>,\<omega\><rsup|N-1>>
        all distinct.

        <\eqnarray*>
          <tformat|<table|<row|<cell|DFT<rsub|\<omega\>><around*|(|P<rsub|0>,\<ldots\>,P<rsub|N-1>|)>>|<cell|=>|<cell|<around*|(|P<around*|(|1|)>,P<around*|(|\<omega\>|)>,P<around*|(|\<omega\><rsup|2>|)>,\<ldots\>,P<around*|(|\<omega\><rsup|N-1>|)>|)>>>>>
        </eqnarray*>

        Corresponds to evaluating <math|P=P<rsub|0>+\<cdots\>+P<rsub|N-1>*X<rsup|N-1>>
        at <math|x<rsub|i>=\<omega\><rsup|i>><vspace|1fn>
      </compact>
    </shown>|<\hidden*>
      <strong|Cyclic polynomials>

      Elements of <math|\<bbb-K\><around*|[|x|]>/<around*|(|X<rsup|N>-1|)>>.
      We have

      <switch|<\shown>
        <\eqnarray*>
          <tformat|<table|<row|<cell|X<rsup|N>-1>|<cell|=>|<cell|<around*|(|X-1|)>*<around*|(|X-\<omega\>|)>*\<cdots\>*<around*|(|X-\<omega\><rsup|N-1>|)>>>>>
        </eqnarray*>
      </shown>|<\hidden>
        <\eqnarray*>
          <tformat|<table|<row|<cell|X<rsup|N>-1>|<cell|=>|<cell|<around*|(|X-1|)>*<around*|(|X-\<omega\>|)>*\<cdots\>*<around*|(|X-\<omega\><rsup|N-1>|)>>>|<row|<cell|\<bbb-K\><around*|[|X|]>/<around*|(|X<rsup|N>-1|)>>|<cell|\<cong\>>|<cell|K<around*|[|X|]>/<around*|(|X-1|)>\<oplus\>K<around*|[|X|]>/<around*|(|X-\<omega\>|)>\<oplus\>\<cdots\>\<oplus\>K<around*|[|X|]>/<around*|(|X-\<omega\><rsup|N-1>|)>>>>>
        </eqnarray*>
      </hidden>|<\hidden>
        <\eqnarray*>
          <tformat|<table|<row|<cell|X<rsup|N>-1>|<cell|=>|<cell|<around*|(|X-1|)>*<around*|(|X-\<omega\>|)>*\<cdots\>*<around*|(|X-\<omega\><rsup|N-1>|)>>>|<row|<cell|\<bbb-K\><around*|[|X|]>/<around*|(|X<rsup|N>-1|)>>|<cell|\<cong\>>|<cell|K<around*|[|X|]>/<around*|(|X-1|)>\<oplus\>K<around*|[|X|]>/<around*|(|X-\<omega\>|)>\<oplus\>\<cdots\>\<oplus\>K<around*|[|X|]>/<around*|(|X-\<omega\><rsup|N-1>|)>>>|<row|<cell|P>|<cell|\<leftrightsquigarrow\>>|<cell|<around*|(|P<around*|(|1|)>,P<around*|(|\<omega\>|)>,\<ldots\>,P<around*|(|\<omega\><rsup|N-1>|)>|)>>>>>
        </eqnarray*>
      </hidden>>
    </hidden*>|<\hidden*>
      <strong|Cyclic convolution <math|\<rightsquigarrow\>> DFT>

      Product of <math|P,Q\<in\>\<bbb-K\><around*|[|X|]>/<around*|(|X<rsup|N>-1|)>>
      also called cyclic convolution

      <\eqnarray*>
        <tformat|<table|<row|<cell|<around*|(|<around*|(|P*Q|)><rsub|0>,\<ldots\>,<around*|(|P*Q|)><rsub|n-1>|)>>|<cell|=>|<cell|DFT<rsub|\<omega\>><rsup|-1><around*|(|DFT<rsub|\<omega\>><around*|(|P<rsub|0>,\<ldots\>,P<rsub|n-1>|)>*DFT<rsub|\<omega\>><around*|(|Q<rsub|0>,\<ldots\>,Q<rsub|n-1>|)>|)>>>>>
      </eqnarray*>
    </hidden*>>
  </hidden>|<\hidden>
    <tit|Discrete Fourier transforms using cyclic convolutions>

    <strong|DFT <math|\<rightsquigarrow\>> Cyclic convolution> [Bluestein 70]

    Assume <math|\<eta\>\<in\>\<bbb-K\>> given with
    <math|\<eta\><rsup|2>=\<omega\>>.

    <\equation*>
      <tabular*|<tformat|<cwith|1|1|1|1|cell-bsep|1spc>|<cwith|2|2|1|1|cell-tsep|1spc>|<table|<row|<cell|f<rsub|i>\<assign\>\<eta\><rsup|i<rsup|2>>,<space|2em>g<rsub|i>\<assign\>\<eta\><rsup|-i<rsup|2>>>>|<row|<cell|f<rsub|i+n>=\<eta\><rsup|<around*|(|i+n|)><rsup|2>>=\<eta\><rsup|i<rsup|2>+n<rsup|2>+2*n*i>=\<eta\><rsup|i<rsup|2>>*\<omega\><rsup|<around*|(|<frac|n|2>+i|)>*n>=f<rsub|i>,<space|2em>g<rsub|i+n>=g<rsub|i>>>>>>
    </equation*>

    Then <math|\<omega\><rsup|i*j>=f<rsub|i>*f<rsub|j>*g<rsub|i-j>>, so for
    all <math|a\<in\>\<bbb-K\><rsup|n>><nbsp>:

    <\equation*>
      <wide|a|^><rsub|i>=DFT<rsub|\<omega\>><around*|(|a|)><rsub|i>=<big|sum><rsub|j=0><rsup|n-1>a<rsub|j>*\<omega\><rsup|i*j>=f<rsub|i>*<big|sum><rsub|j=0><rsup|n-1><around*|(|a<rsub|j>*f<rsub|j>|)>*g<rsub|i-j>
    </equation*>

    One recognizes a cyclic convolution
  </hidden>|<\hidden>
    <tit|Discrete Fourier Transform (DFT)>

    <strong|Cooley\UTuckey method (essentially known to Gau)>

    <\compact>
      <\eqnarray*>
        <tformat|<cwith|2|2|3|3|cell-bsep|1spc>|<table|<row|<cell|P<around*|(|X|)>>|<cell|=>|<cell|A<around*|(|X<rsup|2>|)>+B<around*|(|X<rsup|2>|)>*X>>|<row|<cell|P<around*|(|\<omega\>|)>>|<cell|=>|<cell|A<around*|(|\<omega\><rsup|2>|)>+B<around*|(|\<omega\><rsup|2>|)>*X>>|<row|<cell|<around*|(|P<around*|(|1|)>,P<around*|(|\<omega\>|)>,\<ldots\>,P<around*|(|\<omega\><rsup|N-1>|)>|)>>|<cell|=>|<cell|<around*|(|A<around*|(|1|)>+B<around*|(|1|)>,\<ldots\>,A<around|(|<around*|(|\<omega\><rsup|2>|)><rsup|<frac|N|2>-1>|)>+B<around|(|<around*|(|\<omega\><rsup|2>|)><rsup|<frac|N|2>-1>|)>*\<omega\><rsup|<frac|N|2>-1>,\<nosymbol\>|\<nobracket\>>>>|<row|<cell|>|<cell|>|<cell|<space|1.8spc><around*|\<nobracket\>|A<around*|(|1|)>-B<around*|(|1|)>,\<ldots\>,A<around|(|<around*|(|\<omega\><rsup|2>|)><rsup|<frac|N|2>-1>|)>-B<around|(|<around*|(|\<omega\><rsup|2>|)><rsup|<frac|N|2>-1>|)>*\<omega\><rsup|<frac|N|2>-1>|)>>>>>
      </eqnarray*>
    </compact>

    <with|gr-mode|<tuple|edit|math-at>|gr-frame|<tuple|scale|1cm|<tuple|0.5gw|0.390002gh>>|gr-geometry|<tuple|geometry|1par|0.391284par|center>|gr-text-at-halign|center|gr-grid|<tuple|empty>|gr-grid-old|<tuple|cartesian|<point|0|0>|1>|gr-edit-grid-aspect|<tuple|<tuple|axes|none>|<tuple|1|none>|<tuple|10|none>>|gr-edit-grid|<tuple|empty>|gr-edit-grid-old|<tuple|cartesian|<point|0|0>|1>|<graphics||<math-at|<small|<with|color|red|-\<omega\>>>|<point|2.76680116417516|-1.0420194470168>>|<line|<point|1.0|0.0>|<point|3.0|-2.0>>|<line|<point|5.0|0.0>|<point|7.0|-2.0>>|<line|<point|-3.0|0.0>|<point|-1.0|-2.0>>|<line|<point|-7.0|0.0>|<point|-5.0|-2.0>>|<line|<point|7.0|0.0>|<point|7.0|-2.0>>|<math-at|<small|<with|color|red|-\<omega\><rsup|3>>>|<point|6.75|-1.0>>|<line|<point|3.0|0.0>|<point|3.0|-2.0>>|<line|<point|5.0|-2.0>|<point|7.0|0.0>>|<line|<point|-1.0|0.0>|<point|-1.0|-2.0>>|<line|<point|1.0|-2.0>|<point|3.0|0.0>>|<line|<point|-5.0|0.0>|<point|-5.0|-2.0>>|<line|<point|-3.0|-2.0>|<point|-1.0|0.0>>|<line|<point|-7.0|2.0>|<point|-7.0|5.55111512312578e-17>>|<line|<point|-3.0|2.0>|<point|-3.0|5.55111512312578e-17>>|<spline|<point|-7.0|2.0>|<point|-4.5|1.0>|<point|-3.0|5.55111512312578e-17>>|<line|<point|-1.0|2.0>|<point|-1.0|5.55111512312578e-17>>|<line|<point|1.0|2.0>|<point|1.0|5.55111512312578e-17>>|<line|<point|3.0|2.0>|<point|3.0|5.55111512312578e-17>>|<math-at|<small|<with|color|red|-\<mathi\>>>|<point|4.75|1.5>>|<line|<point|7.0|2.0>|<point|7.0|5.55111512312578e-17>>|<spline|<point|-5.0|5.55111512312578e-17>|<point|-2.5|1.0>|<point|-1.0|2.0>>|<spline|<point|-7.0|5.55111512312578e-17>|<point|-4.5|1.0>|<point|-3.0|2.0>>|<spline|<point|-5.0|2.0>|<point|-2.5|1.0>|<point|-1.0|5.55111512312578e-17>>|<line|<point|-5.0|2.0>|<point|-5.0|5.55111512312578e-17>>|<spline|<point|1.0|2.0>|<point|3.5|1.0>|<point|5.0|5.55111512312578e-17>>|<spline|<point|1.0|5.55111512312578e-17>|<point|3.5|1.0>|<point|5.0|2.0>>|<spline|<point|3.0|2.0>|<point|5.5|1.0>|<point|7.0|5.55111512312578e-17>>|<spline|<point|3.0|5.55111512312578e-17>|<point|5.5|1.0>|<point|7.0|2.0>>|<spline|<point|-5.0|1.97038>|<point|-0.499999999999999|2.97038>|<point|3.0|3.97038>>|<line|<point|-3.0|3.97038>|<point|-3.0|1.97038>>|<line|<point|-1.0|3.97038>|<point|-1.0|1.97038>>|<line|<point|1.0|3.97038>|<point|1.0|1.97038>>|<line|<point|3.0|3.97038>|<point|3.0|1.97038>>|<line|<point|7.0|3.97038>|<point|7.0|1.97038>>|<spline|<point|-7.0|3.97038>|<point|-2.5|2.97038>|<point|1.0|1.97038>>|<spline|<point|-7.0|1.97038>|<point|-2.5|2.97038>|<point|1.0|3.97038>>|<spline|<point|-5.0|3.97038>|<point|-0.499999999999999|2.97038>|<point|3.0|1.97038>>|<spline|<point|-3.0|1.97038>|<point|1.5|2.97038>|<point|5.0|3.97038>>|<spline|<point|-1.0|1.97038>|<point|3.5|2.97038>|<point|7.0|3.97038>>|<line|<point|5.0|0.0>|<point|5.0|-2.0>>|<with|color|red|<math-at|<small|<with|color|red|-1>>|<point|-5.25|-1.0>>>|<line|<point|-7.0|0.0>|<point|-7.0|-2.0>>|<line|<point|-7.0|3.97038>|<point|-7.0|1.97038>>|<line|<point|-5.0|3.97038>|<point|-5.0|1.97038>>|<spline|<point|-3.0|3.97038>|<point|1.5|2.97038>|<point|5.0|1.97038>>|<spline|<point|-1.0|3.97038>|<point|3.5|2.97038>|<point|7.0|1.97038>>|<math-at|<small|<with|color|red|-1>>|<point|2.75|3.47038>>|<math-at|<small|<with|color|red|-1>>|<point|6.75|2.97038>>|<math-at|<small|<with|color|red|-1>>|<point|4.75|2.97038>>|<line|<point|5.0|3.97038>|<point|5.0|1.97038>>|<math-at|<small|<with|color|red|-1>>|<point|0.750000000000001|3.60718924774778>>|<math-at|<small|<with|color|red|-1>>|<point|-1.25|0.75>>|<line|<point|1.0|0.0>|<point|1.0|-2.0>>|<line|<point|-3.0|0.0>|<point|-3.0|-2.0>>|<math-at|<small|<with|color|red|-\<mathi\>>>|<point|6.75|1.19072666073484>>|<line|<point|-7.0|-2.0>|<point|-5.0|0.0>>|<line|<point|5.0|2.0>|<point|5.0|5.55111512312578e-17>>|<with|text-at-halign|center|<math-at|P<rsub|0>|<point|-7|4.25>>>|<with|text-at-halign|center|<math-at|P<rsub|1>|<point|-5|4.25>>>|<with|text-at-halign|center|<math-at|P<rsub|2>|<point|-3|4.25>>>|<with|text-at-halign|center|<math-at|P<rsub|3>|<point|-1|4.25>>>|<with|text-at-halign|center|<math-at|P<rsub|4>|<point|1|4.25>>>|<with|text-at-halign|center|<math-at|P<rsub|5>|<point|3|4.25>>>|<with|text-at-halign|center|<math-at|P<rsub|6>|<point|5|4.25>>>|<with|text-at-halign|center|<math-at|P<rsub|7>|<point|7|4.25>>>|<with|text-at-halign|center|<math-at|P<around*|(|1|)>|<point|-7|-2.75>>>|<with|text-at-halign|center|<math-at|P<around*|(|-<space|-0.4spc>1|)>|<point|-5|-2.75>>>|<with|text-at-halign|center|<math-at|P<around*|(|\<mathi\>|)>|<point|-3|-2.75>>>|<with|text-at-halign|center|<math-at|P<around*|(|-<space|-0.4spc>\<mathi\>|)>|<point|-1|-2.75>>>|<with|text-at-halign|center|<math-at|P<around*|(|\<omega\>|)>|<point|1|-2.75>>>|<with|text-at-halign|center|<math-at|P<around*|(|\<omega\><rsup|5>|)>|<point|3|-2.75>>>|<with|text-at-halign|center|<math-at|P<around*|(|\<omega\><rsup|3>|)>|<point|5|-2.75>>>|<point|-7|3.97038>|<point|-5|3.97038>|<point|-3|3.97038>|<point|-1|3.97038>|<point|1|3.97038>|<point|3|3.97038>|<point|5|3.97038>|<point|7|3.97038>|<point|-7|-2>|<point|-5|-2>|<point|-3|-2>|<point|-1|-2>|<point|1|-2>|<point|3|-2>|<point|5|-2>|<point|7.0|-2.0>|<with|text-at-halign|center|<math-at|P<around*|(|\<omega\><rsup|7>|)>|<point|7.0|-2.8>>>|<math-at|<small|<with|color|red|\<mathi\>>>|<point|-2.3|-1.6>>|<math-at|<small|<with|color|red|-\<mathi\>>>|<point|-1.2|-1.2>>|<math-at|<small|<with|color|red|\<omega\>>>|<point|1.6|-1.6>>|<math-at|<small|<with|color|red|\<omega\><rsup|3>>>|<point|5.4|-1.7>>|<math-at|<small|<with|color|red|\<mathi\>>>|<point|2.375|0.5>>|<math-at|<small|<with|color|red|\<mathi\>>>|<point|4.7|0.6>>|<math-at|<small|<with|color|red|-1>>|<point|-3.14500000000013|1.3>>>>
  </hidden>|<\hidden>
    <tit|Discrete Fourier Transform (DFT)>

    <unroll|<\shown>
      <strong|Direct transform>

      <\compact>
        <\eqnarray*>
          <tformat|<table|<row|<cell|DFT<rsub|\<omega\>><around*|(|P<rsub|0>,\<ldots\>,P<rsub|N-1>|)>>|<cell|=>|<cell|<around*|(|P<around*|(|1|)>,P<around*|(|\<omega\>|)>,P<around*|(|\<omega\><rsup|2>|)>,\<ldots\>,P<around*|(|\<omega\><rsup|N-1>|)>|)>>>>>
        </eqnarray*>
      </compact>
    </shown>|<\hidden*>
      <strong|Inverse transform>

      <\eqnarray*>
        <tformat|<table|<row|<cell|DFT<rsub|\<omega\>><rsup|-1>>|<cell|=>|<cell|<tfrac|1|N>*DFT<rsub|\<omega\><rsup|-1>>>>>>
      </eqnarray*>

      Interpolation <math|\<leftrightsquigarrow\>> Evaluation<vspace|1fn>
    </hidden*>|<\hidden*>
      <strong|Variants>

      <\itemize>
        <item><math|\<bbb-K\>=\<bbb-C\><rsub|b>>: <strong|complex DFT>,
        complex fixed-point arithmetic with <math|b>-bit precision

        <item><math|\<bbb-K\>=\<bbb-F\><rsub|p>>, <strong|modular DFT>, with
        <math|p> prime number of the form <math|k*2<rsup|N>\<pm\>1> [Pollard
        71]

        <item><math|\<bbb-K\>=\<bbb-L\><around*|[|Y|]>/<around*|(|Y<rsup|2<rsup|N>>\<pm\>1|)>>,
        <strong|synthetic DFT>, <em| la> Schnhage\UStrassen
      </itemize>
    </hidden*>>

    \;
  </hidden>|<\hidden>
    <tit|Discrete Fourier Transform (II) >

    \;

    <htab|5mm><with|gr-mode|<tuple|group-edit|rotate>|gr-frame|<tuple|scale|1cm|<tuple|0.5gw|0.5gh>>|gr-geometry|<tuple|geometry|1par|0.399989par|center>|gr-grid|<tuple|empty>|gr-grid-old|<tuple|cartesian|<point|0|0>|1>|gr-edit-grid-aspect|<tuple|<tuple|axes|none>|<tuple|1|none>|<tuple|4|none>>|gr-edit-grid|<tuple|empty>|gr-edit-grid-old|<tuple|cartesian|<point|0|0>|1>|gr-grid-aspect|<tuple|<tuple|axes|#808080>|<tuple|1|#c0c0c0>|<tuple|4|#e0e0ff>>|gr-grid-aspect-props|<tuple|<tuple|axes|#808080>|<tuple|1|#c0c0c0>|<tuple|4|#e0e0ff>>|gr-text-at-halign|right|gr-text-at-valign|center|gr-auto-crop|true|<graphics||<spline|<point|-0.998900250227728|0.0389919862086866>|<point|-2.24656014484693|-0.466819033203512>|<point|-2.99422545243713|-0.970303479662431>>|<spline|<point|-1.00355339613429|1.03898116026667>|<point|-3.50119975832598|0.527353708471266>|<point|-4.99885694645968|0.0203794025824258>>|<point|-1.00820654204086|2.03897033432466>|<point|1.01038438970137|-1.95168007009415>|<point|2.01037356375937|-1.94702692418759>|<line|<point|2.00572041785279|-0.947037750129603>|<point|1.01038438970137|-1.95168007009415>>|<point|4.01035191187533|-1.93772063237446>|<point|5.01034108593332|-1.93306748646789>|<line|<point|6.0103302599913|-1.92841434056134>|<point|5.00568794002675|-0.933078312409917>>|<point|3.99173932824907|2.06223606385748>|<spline|<point|4.99638164821362|1.06690003570606>|<point|-0.00589079502958831|1.54362889320223>|<point|-3.00818489015683|2.02966404251152>>|<spline|<point|6.00102396817817|0.0715640075546418>|<point|3.49872446007992|0.559925729817222>|<point|1.99641412603967|1.05294059798637>>|<spline|<point|5.99171767636504|2.07154235567061>|<point|0.994098379028402|1.5482820391088>|<point|-2.00354257019228|1.0343280143601>>|<spline|<point|6.9963599963296|1.07620632751919>|<point|1.99408755308638|1.55293518501535>|<point|-1.00820654204086|2.03897033432466>>|<line|<point|7.01031943404929|-1.92376119465476>|<point|6.99170685042303|2.07619550157718>>|<spline|<point|-1.99888942428571|0.0343388403021212>|<point|-4.50118893238396|0.522700562564702>|<point|-6.00349926642422|1.01571543073385>>|<line|<point|-2.98957230653057|-1.97029265372042>|<point|-3.00818489015683|2.02966404251152>>|<point|0.0103952156433888|-1.95633321600072>|<point|-2.00819571609884|2.03431718841809>|<line|<point|0.0103952156433888|-1.95633321600072>|<point|-0.00821736798287098|2.04362348023122>>|<spline|<point|0.00108892383025883|0.0436451321152511>|<point|-2.50121058426798|0.532006854377832>|<point|-4.00352091830825|1.02502172254697>>|<spline|<point|3.00570959191078|-0.942384604223038>|<point|1.75339655138502|-0.448206449577253>|<point|1.00107809788825|0.0482982780218166>>|<point|3.01036273781734|-1.94237377828103>|<spline|<point|4.0010456200622|0.0622577157415109>|<point|2.753385725443|-0.443553303670687>|<point|2.00572041785279|-0.947037750129603>>|<point|2.99175015419109|2.05758291795092>|<spline|<point|4.99638164821362|1.06690003570606>|<point|2.49873528602194|0.555272583910657>|<point|1.00107809788825|0.0482982780218166>>|<spline|<point|7.00566628814272|-0.923772020596776>|<point|5.75335324761696|-0.429593865950993>|<point|5.00103479412019|0.0669108616480763>>|<spline|<point|8.00100231629414|0.0808702993677716>|<point|6.75334242167495|-0.424940720044427>|<point|6.00567711408474|-0.928425166503342>>|<spline|<point|5.99637082227161|1.07155318161263>|<point|0.994098379028402|1.5482820391088>|<point|-2.00819571609884|2.03431718841809>>|<point|6.99170685042303|2.07619550157718>|<spline|<point|6.99170685042303|2.07619550157718>|<point|1.99408755308638|1.55293518501535>|<point|-1.00355339613429|1.03898116026667>>|<line|<point|8.01030860810727|-1.9191080487482>|<point|7.99169602448102|2.08084864748374>>|<line|<point|-3.98956148058855|-1.97494579962698>|<point|-4.00817406421481|2.02501089660497>>|<line|<point|-3.98956148058855|-1.97494579962698>|<point|-4.9942038005531|-0.979609771475562>>|<line|<point|-1.99423627837915|-0.965650333755865>|<point|-2.98957230653057|-1.97029265372042>>|<point|-4.00817406421481|2.02501089660497>|<spline|<point|0.00108892383025883|0.0436451321152511>|<point|-1.24657097078893|-0.462165887296947>|<point|-1.99423627837915|-0.965650333755865>>|<line|<point|0.0103952156433888|-1.95633321600072>|<point|-0.994247104321163|-0.96099718784929>>|<line|<point|2.01037356375937|-1.94702692418759>|<point|1.00573124379481|-0.951690896036169>>|<point|-0.00821736798287098|2.04362348023122>|<spline|<point|2.99175015419109|2.05758291795092>|<point|-2.00586914314556|1.5343226013891>|<point|-5.00351009236623|1.02036857664041>>|<spline|<point|3.99173932824907|2.06223606385748>|<point|-1.00587996908758|1.53897574729567>|<point|-4.00352091830825|1.02502172254697>>|<spline|<point|4.00569876596877|-0.937731458316473>|<point|2.753385725443|-0.443553303670687>|<point|2.00106727194623|0.052951423928381>>|<point|8.01030860810727|-1.9191080487482>|<spline|<point|5.99637082227161|1.07155318161263>|<point|3.49872446007992|0.559925729817222>|<point|2.00106727194623|0.052951423928381>>|<spline|<point|6.9963599963296|1.07620632751919>|<point|4.49871363413791|0.564578875723788>|<point|3.00105644600421|0.0576045698349464>>|<spline|<point|7.00101314223616|0.0762171534612072>|<point|4.49871363413791|0.564578875723788>|<point|2.99640330009765|1.05759374389294>>|<spline|<point|8.00100231629414|0.0808702993677716>|<point|5.4987028081959|0.569232021630352>|<point|3.99639247415563|1.0622468897995>>|<spline|<point|-4.99885694645968|0.0203794025824258>|<point|-6.24651684107887|-0.485431616829773>|<point|-6.99418214866908|-0.988916063288693>>|<line|<point|-5.98953982870452|-1.98425209144011>|<point|-6.00815241233078|2.01570460479183>>|<spline|<point|-3.99886777240168|0.0250325484889914>|<point|-5.24652766702088|-0.480778470923209>|<point|-5.9941929746111|-0.984262917382127>>|<spline|<point|-4.9942038005531|-0.979609771475562>|<point|-6.24651684107887|-0.485431616829773>|<point|-6.99883529457564|0.0110731107692951>>|<point|-2.98957230653057|-1.97029265372042>|<spline|<point|-3.99421462649512|-0.974956625568986>|<point|-5.24652766702088|-0.480778470923209>|<point|-5.99884612051765|0.0157262566758605>>|<spline|<point|-2.00354257019228|1.0343280143601>|<point|-4.50118893238396|0.522700562564702>|<point|-5.99884612051765|0.0157262566758605>>|<line|<point|-1.98958313247258|-1.96563950781385>|<point|-2.99422545243713|-0.970303479662431>>|<line|<point|4.00569876596877|-0.937731458316473>|<point|3.01036273781734|-1.94237377828103>>|<spline|<point|2.99640330009765|1.05759374389294>|<point|-2.00586914314556|1.5343226013891>|<point|-5.0081632382728|2.02035775069839>>|<spline|<point|3.99639247415563|1.0622468897995>|<point|-1.00587996908758|1.53897574729567>|<point|-4.00817406421481|2.02501089660497>>|<point|7.01031943404929|-1.92376119465476>|<line|<point|8.01030860810727|-1.9191080487482>|<point|7.00566628814272|-0.923772020596776>>|<spline|<point|5.00103479412019|0.0669108616480763>|<point|2.49873528602194|0.555272583910657>|<point|0.996424951981675|1.0482874520798>>|<line|<point|5.01034108593332|-1.93306748646789>|<point|4.99172850230706|2.06688920976406>>|<point|4.99172850230706|2.06688920976406>|<point|-6.00815241233078|2.01570460479183>|<line|<point|-6.98952900276251|-1.98890523734668>|<point|-7.00814158638878|2.01105145888527>>|<point|-4.98955065464654|-1.97959894553355>|<line|<point|-5.9941929746111|-0.984262917382127>|<point|-6.98952900276251|-1.98890523734668>>|<line|<point|-3.99421462649512|-0.974956625568986>|<point|-4.98955065464654|-1.97959894553355>>|<point|-3.98956148058855|-1.97494579962698>|<point|-1.98958313247258|-1.96563950781385>|<point|-3.00818489015683|2.02966404251152>|<spline|<point|-0.998900250227728|0.0389919862086866>|<point|-3.50119975832598|0.527353708471266>|<point|-5.00351009236623|1.02036857664041>>|<spline|<point|-0.994247104321163|-0.96099718784929>|<point|-2.24656014484693|-0.466819033203512>|<point|-2.9988785983437|0.0296856943955568>>|<spline|<point|-0.00356422207630663|1.04363430617324>|<point|-2.50121058426798|0.532006854377832>|<point|-3.99886777240168|0.0250325484889914>>|<spline|<point|0.00574206973682333|-0.956344041942734>|<point|-1.24657097078893|-0.462165887296947>|<point|-1.99888942428571|0.0343388403021212>>|<line|<point|1.01038438970137|-1.95168007009415>|<point|0.99177180607511|2.04827662613778>>|<point|0.99177180607511|2.04827662613778>|<line|<point|2.01037356375937|-1.94702692418759>|<point|1.99176098013309|2.05292977204436>>|<point|1.99176098013309|2.05292977204436>|<point|-7.00814158638878|2.01105145888527>|<line|<point|-5.98953982870452|-1.98425209144011>|<point|-6.99418214866908|-0.988916063288693>>|<line|<point|-4.98955065464654|-1.97959894553355>|<point|-5.0081632382728|2.02035775069839>>|<spline|<point|-3.00353174425026|1.02967486845355>|<point|-5.50117810644194|0.518047416658137>|<point|-6.99883529457564|0.0110731107692951>>|<point|-0.989593958414598|-1.96098636190728>|<line|<point|0.00574206973682333|-0.956344041942734>|<point|-0.989593958414598|-1.96098636190728>>|<spline|<point|0.99177180607511|2.04827662613778>|<point|-4.00584749126153|1.52501630957597>|<point|-7.00348844048221|1.01106228482728>>|<spline|<point|1.99176098013309|2.05292977204436>|<point|-3.00585831720355|1.52966945548254>|<point|-6.00349926642422|1.01571543073385>>|<spline|<point|3.00105644600421|0.0576045698349464>|<point|1.75339655138502|-0.448206449577253>|<point|1.00573124379481|-0.951690896036169>>|<point|6.0103302599913|-1.92841434056134>|<line|<point|6.00567711408474|-0.928425166503342>|<point|5.01034108593332|-1.93306748646789>>|<spline|<point|4.99172850230706|2.06688920976406>|<point|-0.00589079502958831|1.54362889320223>|<point|-3.00353174425026|1.02967486845355>>|<spline|<point|7.00101314223616|0.0762171534612072>|<point|5.75335324761696|-0.429593865950993>|<point|5.00568794002675|-0.933078312409917>>|<line|<point|6.0103302599913|-1.92841434056134>|<point|5.99171767636504|2.07154235567061>>|<spline|<point|7.99634917038758|1.08085947342576>|<point|2.99407672714436|1.55758833092193>|<point|-0.00821736798287098|2.04362348023122>>|<point|7.99169602448102|2.08084864748374>|<with|color|dark
    grey|<spline|<point|-7.5|2>|<point|-7.75|0.0>|<point|-7.5|-2.0>>>|<with|color|dark
    grey|<spline|<point|-7|2.5>|<point|0.0|2.75>|<point|8.0|2.5>>>|<with|text-at-valign|center|text-at-halign|right|<math-at|lg
    N|<point|-8|0>>>|<point|-6.98952900276251|-1.98890523734668>|<point|-5.98953982870452|-1.98425209144011>|<point|-5.0081632382728|2.02035775069839>|<spline|<point|-2.9988785983437|0.0296856943955568>|<point|-5.50117810644194|0.518047416658137>|<point|-7.00348844048221|1.01106228482728>>|<line|<point|-1.98958313247258|-1.96563950781385>|<point|-2.00819571609884|2.03431718841809>>|<line|<point|-0.989593958414598|-1.96098636190728>|<point|-1.00820654204086|2.03897033432466>>|<spline|<point|0.996424951981675|1.0482874520798>|<point|-4.00584749126153|1.52501630957597>|<point|-7.00814158638878|2.01105145888527>>|<spline|<point|1.99641412603967|1.05294059798637>|<point|-3.00585831720355|1.52966945548254>|<point|-6.00815241233078|2.01570460479183>>|<line|<point|4.01035191187533|-1.93772063237446>|<point|3.00570959191078|-0.942384604223038>>|<line|<point|3.01036273781734|-1.94237377828103>|<point|2.99175015419109|2.05758291795092>>|<line|<point|4.01035191187533|-1.93772063237446>|<point|3.99173932824907|2.06223606385748>>|<line|<point|7.01031943404929|-1.92376119465476>|<point|8.00565546220072|-0.919118874690221>>|<spline|<point|8.00565546220072|-0.919118874690221>|<point|6.75334242167495|-0.424940720044427>|<point|6.00102396817817|0.0715640075546418>>|<point|5.99171767636504|2.07154235567061>|<spline|<point|7.99634917038758|1.08085947342576>|<point|5.4987028081959|0.569232021630352>|<point|4.0010456200622|0.0622577157415109>>|<spline|<point|7.99169602448102|2.08084864748374>|<point|2.99407672714436|1.55758833092193>|<point|-0.00356422207630663|1.04363430617324>>|<with|text-at-halign|center|<math-at|N|<point|0.511046434713586|3.04903095647572>>>>><space|2em><htab|5mm>

    \;

    Cost of one DFT<nbsp>: <math|<frac|1|2>*N*lg N> \Pbutterflies\Q
    <math|\<rightsquigarrow\>> <math|O<around*|(|N*lg N|)>> operations in
    <math|\<bbb-K\>>

    \;

    <switch|<\shown>
      <tabular|<tformat|<twith|table-width|1par>|<twith|table-hmode|exact>|<cwith|1|-1|1|-1|cell-tsep|1spc>|<cwith|1|-1|1|-1|cell-bsep|1spc>|<cwith|2|2|2|4|cell-tsep|1spc>|<cwith|2|2|2|4|cell-bsep|1spc>|<cwith|3|3|4|4|cell-tsep|1spc>|<cwith|3|3|4|4|cell-bsep|1spc>|<cwith|3|3|4|4|cell-tsep|1spc>|<cwith|3|3|4|4|cell-bsep|1spc>|<cwith|3|3|4|4|cell-tsep|1spc>|<cwith|3|3|4|4|cell-bsep|1spc>|<table|<row|<cell|<pastel|Complex
      DFT>>|<cell|<pastel|<math|N\<asymp\>n/lg
      n>>>|<cell|<pastel|<math|<math-ss|M><rsub|\<bbb-K\>><around*|(|1|)>=O<around*|(|<math-ss|I><around*|(|lg
      n|)>|)>>>>|<cell|<pastel|<math|<math-ss|I><around*|(|n|)>=O<around*|(|n*lg
      n*<math-ss|I><around*|(|lg n|)>+n*lg
      n|)>>>>>|<row|<cell|<pastel|Modular
      DFT>>|<cell|<pastel|<math|N\<asymp\>n/lg
      n>>>|<cell|<pastel|<math|<math-ss|M><rsub|\<bbb-K\>><around*|(|1|)>=O<around*|(|<math-ss|I><around*|(|lg
      n|)>|)>>>>|<cell|<pastel|<math|<math-ss|I><around*|(|n|)>=O<around*|(|n*lg
      n*<math-ss|I><around*|(|lg n|)>+n*lg
      n|)>>>>>|<row|<cell|<pastel|Synthetic
      DFT>>|<cell|<pastel|<math|N\<asymp\><sqrt|n>>>>|<cell|<pastel|butterfly
      <math|\<rightsquigarrow\>> <math|O<around*|(|<sqrt|n>|)>>>>|<cell|<pastel|<math|<math-ss|<math|<math-ss|I><around*|(|n|)>=O<around*|(|n*lg
      n*<sqrt|n>+<sqrt|n>*<math-ss|I><around*|(|<sqrt|n>|)>|)>>>>>>>>>>
    </shown>|<\hidden>
      <tabular|<tformat|<twith|table-width|1par>|<twith|table-hmode|exact>|<cwith|1|-1|1|-1|cell-tsep|1spc>|<cwith|1|-1|1|-1|cell-bsep|1spc>|<cwith|2|3|1|4|cell-tsep|1spc>|<cwith|2|3|1|4|cell-bsep|1spc>|<cwith|2|2|2|4|cell-tsep|1spc>|<cwith|2|2|2|4|cell-bsep|1spc>|<cwith|3|3|4|4|cell-tsep|1spc>|<cwith|3|3|4|4|cell-bsep|1spc>|<cwith|3|3|4|4|cell-tsep|1spc>|<cwith|3|3|4|4|cell-bsep|1spc>|<cwith|3|3|4|4|cell-tsep|1spc>|<cwith|3|3|4|4|cell-bsep|1spc>|<table|<row|<cell|Complex
      DFT>|<cell|<math|N\<asymp\>n/lg n>>|<cell|<math|<math-ss|M><rsub|\<bbb-K\>><around*|(|1|)>=O<around*|(|<math-ss|I><around*|(|lg
      n|)>|)>>>|<cell|<math|<math-ss|I><around*|(|n|)>=O<around*|(|n*lg
      n*<math-ss|I><around*|(|lg n|)>+n*lg n|)>>>>|<row|<cell|<pastel|Modular
      DFT>>|<cell|<pastel|<math|N\<asymp\>n/lg
      n>>>|<cell|<pastel|<math|<math-ss|M><rsub|\<bbb-K\>><around*|(|1|)>=O<around*|(|<math-ss|I><around*|(|lg
      n|)>|)>>>>|<cell|<pastel|<math|<math-ss|I><around*|(|n|)>=O<around*|(|n*lg
      n*<math-ss|I><around*|(|lg n|)>+n*lg
      n|)>>>>>|<row|<cell|<pastel|Synthetic
      DFT>>|<cell|<pastel|<math|N\<asymp\><sqrt|n>>>>|<cell|<pastel|butterfly
      <math|\<rightsquigarrow\>> <math|O<around*|(|<sqrt|n>|)>>>>|<cell|<pastel|<math|<math-ss|<math|<math-ss|I><around*|(|n|)>=O<around*|(|n*lg
      n*<sqrt|n>+<sqrt|n>*<math-ss|I><around*|(|<sqrt|n>|)>|)>>>>>>>>>>
    </hidden>|<\hidden>
      <tabular|<tformat|<twith|table-width|1par>|<twith|table-hmode|exact>|<cwith|1|-1|1|-1|cell-tsep|1spc>|<cwith|1|-1|1|-1|cell-bsep|1spc>|<cwith|3|3|1|4|cell-tsep|1spc>|<cwith|3|3|1|4|cell-bsep|1spc>|<cwith|3|3|1|4|cell-tsep|1spc>|<cwith|3|3|1|4|cell-bsep|1spc>|<table|<row|<cell|Complex
      DFT>|<cell|<math|N\<asymp\>n/lg n>>|<cell|<math|<math-ss|M><rsub|\<bbb-K\>><around*|(|1|)>=O<around*|(|<math-ss|I><around*|(|lg
      n|)>|)>>>|<cell|<math|<math-ss|I><around*|(|n|)>=O<around*|(|n*lg
      n*<math-ss|I><around*|(|lg n|)>+n*lg n|)>>>>|<row|<cell|Modular
      DFT>|<cell|<math|N\<asymp\>n/lg n>>|<cell|<math|<math-ss|M><rsub|\<bbb-K\>><around*|(|1|)>=O<around*|(|<math-ss|I><around*|(|lg
      n|)>|)>>>|<cell|<math|<math-ss|I><around*|(|n|)>=O<around*|(|n*lg
      n*<math-ss|I><around*|(|lg n|)>+n*lg
      n|)>>>>|<row|<cell|<pastel|Synthetic
      DFT>>|<cell|<pastel|<math|N\<asymp\><sqrt|n>>>>|<cell|<pastel|butterfly
      <math|\<rightsquigarrow\>> <math|O<around*|(|<sqrt|n>|)>>>>|<cell|<pastel|<math|<math-ss|<math|<math-ss|I><around*|(|n|)>=O<around*|(|n*lg
      n*<sqrt|n>+<sqrt|n>*<math-ss|I><around*|(|<sqrt|n>|)>|)>>>>>>>>>>
    </hidden>|<\hidden>
      <tabular|<tformat|<twith|table-width|1par>|<twith|table-hmode|exact>|<cwith|1|-1|1|-1|cell-tsep|1spc>|<cwith|1|-1|1|-1|cell-bsep|1spc>|<table|<row|<cell|Complex
      DFT>|<cell|<math|N\<asymp\>n/lg n>>|<cell|<math|<math-ss|M><rsub|\<bbb-K\>><around*|(|1|)>=O<around*|(|<math-ss|I><around*|(|lg
      n|)>|)>>>|<cell|<math|<math-ss|I><around*|(|n|)>=O<around*|(|n*lg
      n*<math-ss|I><around*|(|lg n|)>+n*lg n|)>>>>|<row|<cell|Modular
      DFT>|<cell|<math|N\<asymp\>n/lg n>>|<cell|<math|<math-ss|M><rsub|\<bbb-K\>><around*|(|1|)>=O<around*|(|<math-ss|I><around*|(|lg
      n|)>|)>>>|<cell|<math|<math-ss|I><around*|(|n|)>=O<around*|(|n*lg
      n*<math-ss|I><around*|(|lg n|)>+n*lg n|)>>>>|<row|<cell|Synthetic
      DFT>|<cell|<math|N\<asymp\><sqrt|n>>>|<cell|butterfly
      <math|\<rightsquigarrow\>> <math|O<around*|(|<sqrt|n>|)>>>|<cell|<math|<math-ss|I><around*|(|n|)>=O<around*|(|n*lg
      n*<sqrt|n>+<sqrt|n>*<math-ss|I><around*|(|<sqrt|n>|)>|)>>>>>>>
    </hidden>|<\hidden>
      <tabular|<tformat|<twith|table-width|1par>|<twith|table-hmode|exact>|<cwith|1|-1|1|-1|cell-tsep|1spc>|<cwith|1|-1|1|-1|cell-bsep|1spc>|<table|<row|<cell|Complex
      DFT>|<cell|<math|N\<asymp\>n/lg n>>|<cell|<math|<math-ss|M><rsub|\<bbb-K\>><around*|(|1|)>=O<around*|(|<math-ss|I><around*|(|lg
      n|)>|)>>>|<cell|<math|<math-ss|I><around*|(|n|)>=O<around*|(|n*lg n*lg
      lg n*lg lg lg n*\<cdots\>|)>>>>|<row|<cell|Modular
      DFT>|<cell|<math|N\<asymp\>n/lg n>>|<cell|<math|<math-ss|M><rsub|\<bbb-K\>><around*|(|1|)>=O<around*|(|<math-ss|I><around*|(|lg
      n|)>|)>>>|<cell|<math|<math-ss|I><around*|(|n|)>=O<around*|(|n*lg n*lg
      lg n*lg lg lg n*\<cdots\>|)>>>>|<row|<cell|Synthetic
      DFT>|<cell|<math|N\<asymp\><sqrt|n>>>|<cell|butterfly
      <math|\<rightsquigarrow\>> <math|O<around*|(|<sqrt|n>|)>>>|<cell|<math|<math-ss|I><around*|(|n|)>=O<around*|(|n*lg
      n*lg lg n|)>>>>>>>
    </hidden>>
  </hidden>|<\hidden>
    <tit|Variants of Discrete Fourier Transform>

    \;

    <switch|<\shown>
      <with|gr-mode|<tuple|edit|text-at>|gr-frame|<tuple|scale|1cm|<tuple|0.5gw|0.5gh>>|gr-geometry|<tuple|geometry|1par|0.526078par|center>|gr-text-at-halign|center|gr-text-at-valign|center|gr-fill-color|pastel
      blue|<graphics||<point|-0.5|4>|<point|-1.5|4>|<point|-2.5|4>|<point|-3.5|4>|<point|-4.5|4>|<point|-5.5|4>|<point|-6.5|4>|<point|-7.5|4>|<with|color|red|<line|<point|1.5|3.0>|<point|1.5|4.0>>>|<point|0.5|4>|<point|1.5|4>|<point|2.5|4>|<point|3.5|4>|<point|4.5|4>|<point|5.5|4>|<point|6.5|4>|<point|7.5|4>|<line|<point|-7.5|4>|<point|-7.5|3.0>>|<line|<point|-7.5|4>|<point|-6.5|3.0>>|<line|<point|-6.5|4>|<point|-6.5|3.0>>|<line|<point|-6.5|4>|<point|-7.5|3.0>>|<line|<point|-5.5|4>|<point|-5.5|3.0>>|<line|<point|-5.5|4>|<point|-4.5|3.0>>|<line|<point|-4.5|4>|<point|-4.5|3.0>>|<line|<point|-4.5|4>|<point|-5.5|3.0>>|<line|<point|-3.5|4>|<point|-3.5|3.0>|<point|-2.5|4.0>|<point|-2.5|3.0>|<point|-3.5|4.0>>|<line|<point|-1.5|4>|<point|-1.5|3.0>|<point|-0.5|4.0>|<point|-0.5|3.0>|<point|-1.5|4.0>>|<line|<point|2.5|4>|<point|2.5|3.0>|<point|3.5|4.0>|<point|3.5|3.0>|<point|2.5|4.0>>|<line|<point|4.5|4>|<point|4.5|3.0>|<point|5.5|4.0>|<point|5.5|3.0>|<point|4.5|4.0>>|<line|<point|6.5|4>|<point|6.5|3.0>|<point|7.5|4.0>|<point|7.5|3.0>|<point|6.5|4.0>>|<with|fill-color|pastel
      blue|<cline|<point|-8|3>|<point|-8.0|2.0>|<point|8.0|2.0>|<point|8.0|3.0>>>|<line|<point|6.5|2.0>|<point|6.5|1.0>|<point|7.5|2.0>|<point|7.5|1.0>|<point|6.5|2.0>>|<line|<point|2.5|2.0>|<point|2.5|1.0>|<point|3.5|2.0>|<point|3.5|1.0>|<point|2.5|2.0>>|<line|<point|4.5|2.0>|<point|4.5|1.0>|<point|5.5|2.0>|<point|5.5|1.0>|<point|4.5|2.0>>|<line|<point|-1.5|2.0>|<point|-1.5|1.0>|<point|-0.5|2.0>|<point|-0.5|1.0>|<point|-1.5|2.0>>|<line|<point|-4.5|2.0>|<point|-4.5|1.0>>|<line|<point|-3.5|2.0>|<point|-3.5|1.0>|<point|-2.5|2.0>|<point|-2.5|1.0>|<point|-3.5|2.0>>|<line|<point|-5.5|2.0>|<point|-4.5|1.0>>|<line|<point|-4.5|2.0>|<point|-5.5|1.0>>|<line|<point|-5.5|2.0>|<point|-5.5|1.0>>|<line|<point|-6.5|2.0>|<point|-6.5|1.0>>|<line|<point|-7.5|2.0>|<point|-6.5|1.0>>|<line|<point|-6.5|2.0>|<point|-7.5|1.0>>|<line|<point|-7.5|2.0>|<point|-7.5|1.0>>|<with|fill-color|pastel
      blue|<cline|<point|-8.0|1.0>|<point|-8.0|0.0>|<point|8.0|0.0>|<point|8.0|1.0>>>|<line|<point|6.5|0.0>|<point|6.5|-1.0>|<point|7.5|0.0>|<point|7.5|-1.0>|<point|6.5|0.0>>|<line|<point|4.5|0.0>|<point|4.5|-1.0>|<point|5.5|0.0>|<point|5.5|-1.0>|<point|4.5|0.0>>|<line|<point|2.5|0.0>|<point|2.5|-1.0>|<point|3.5|0.0>|<point|3.5|-1.0>|<point|2.5|0.0>>|<line|<point|-1.5|0.0>|<point|-1.5|-1.0>|<point|-0.5|0.0>|<point|-0.5|-1.0>|<point|-1.5|0.0>>|<line|<point|-3.5|0.0>|<point|-3.5|-1.0>|<point|-2.5|0.0>|<point|-2.5|-1.0>|<point|-3.5|0.0>>|<line|<point|-4.5|0.0>|<point|-4.5|-1.0>>|<line|<point|-5.5|0.0>|<point|-4.5|-1.0>>|<line|<point|-4.5|0.0>|<point|-5.5|-1.0>>|<line|<point|-5.5|0.0>|<point|-5.5|-1.0>>|<line|<point|-6.5|0.0>|<point|-6.5|-1.0>>|<line|<point|-7.5|0.0>|<point|-6.5|-1.0>>|<line|<point|-6.5|0.0>|<point|-7.5|-1.0>>|<line|<point|-7.5|0.0>|<point|-7.5|-1.0>>|<with|fill-color|pastel
      blue|<cline|<point|-8.0|-1.0>|<point|-8.0|-2.0>|<point|8.0|-2.0>|<point|8.0|-1.0>>>|<line|<point|6.5|-2.0>|<point|6.5|-3.0>|<point|7.5|-2.0>|<point|7.5|-3.0>|<point|6.5|-2.0>>|<line|<point|4.5|-2.0>|<point|4.5|-3.0>|<point|5.5|-2.0>|<point|5.5|-3.0>|<point|4.5|-2.0>>|<line|<point|2.5|-2.0>|<point|2.5|-3.0>|<point|3.5|-2.0>|<point|3.5|-3.0>|<point|2.5|-2.0>>|<line|<point|-1.5|-2.0>|<point|-1.5|-3.0>|<point|-0.5|-2.0>|<point|-0.5|-3.0>|<point|-1.5|-2.0>>|<line|<point|-3.5|-2.0>|<point|-3.5|-3.0>|<point|-2.5|-2.0>|<point|-2.5|-3.0>|<point|-3.5|-2.0>>|<line|<point|-4.5|-2.0>|<point|-4.5|-3.0>>|<line|<point|-5.5|-2.0>|<point|-4.5|-3.0>>|<line|<point|-4.5|-2.0>|<point|-5.5|-3.0>>|<line|<point|-5.5|-2.0>|<point|-5.5|-3.0>>|<line|<point|-6.5|-2.0>|<point|-6.5|-3.0>>|<line|<point|-7.5|-2.0>|<point|-6.5|-3.0>>|<line|<point|-6.5|-2.0>|<point|-7.5|-3.0>>|<line|<point|-7.5|-2.0>|<point|-7.5|-3.0>>|<point|-7.5|-3>|<point|-6.5|-3>|<point|-5.5|-3>|<point|-4.5|-3>|<point|-3.5|-3>|<point|-2.5|-3>|<point|-1.5|-3>|<point|-0.5|-3>|<point|0.5|-3>|<point|1.5|-3>|<point|2.5|-3>|<point|3.5|-3>|<point|4.5|-3>|<point|5.5|-3>|<point|6.5|-3>|<point|7.5|-3>|<with|text-at-valign|center|text-at-halign|center|<text-at|Permutation|<point|-4.0|2.5>>>|<with|text-at-valign|center|text-at-halign|center|<text-at|Permutation|<point|-4.0|0.5>>>|<with|text-at-valign|center|text-at-halign|center|<text-at|Permutation|<point|-4.0|-1.5>>>|<with|color|red|<line|<point|1.5|1.0>|<point|1.5|2.0>>>|<with|color|red|<line|<point|1.47936234951713|-1.0>|<point|1.47936234951713|0.0>>>|<with|color|red|<line|<point|1.5|-3.0>|<point|1.5|-2.0>>>|<with|color|red|<line|<point|1.5|4>|<point|0.5|3.0>>>|<with|color|red|<line|<point|1.5|2>|<point|0.5|1.0>>>|<with|color|red|<line|<point|1.5|-2>|<point|0.5|-3.0>>>|<with|opacity|50%|<line|<point|1.5|3>|<point|0.5|4.0>|<point|0.5|3.0>>>|<with|opacity|50%|<line|<point|1.5|1>|<point|0.5|2.0>|<point|0.5|1.0>>>|<with|color|red|<line|<point|1.47936234951713|0.0>|<point|0.5|-1.0>>>|<with|opacity|50%|<line|<point|1.47936|-1>|<point|0.5|0.0>|<point|0.5|-1.0>>>|<with|opacity|50%|<line|<point|1.5|-3>|<point|0.5|-2.0>|<point|0.5|-3.0>>>|<with|color|red|text-at-valign|center|text-at-halign|center|<math-at|<small|<with|color|red|\<mathi\>>>|<point|1.0|1.75>>>|<with|color|red|text-at-valign|center|text-at-halign|center|<math-at|<small|<with|color|red|-\<mathi\>>>|<point|1.75|1.5>>>|<with|color|red|text-at-valign|center|text-at-halign|center|<math-at|<small|<with|color|red|1>>|<point|1.0|3.75>>>|<with|color|red|text-at-valign|center|text-at-halign|center|<math-at|<small|<with|color|red|-1>>|<point|1.75|3.5>>>|<with|color|red|text-at-valign|center|text-at-halign|center|<math-at|<small|<with|color|red|-\<omega\><rsup|2>>>|<point|2.0|-0.5>>>|<with|color|red|text-at-valign|center|text-at-halign|center|<math-at|<small|<with|color|red|\<omega\><rsup|2>>>|<point|0.75|-0.255268746936776>>>|<with|color|red|text-at-valign|center|text-at-halign|center|<math-at|<small|<with|color|red|\<omega\>>>|<point|0.75|-2.25>>>|<with|color|red|text-at-valign|center|text-at-halign|center|<math-at|<small|<with|color|red|-\<omega\>>>|<point|2.0|-2.5>>>>>
    </shown>|<\hidden>
      <with|gr-mode|<tuple|edit|text-at>|gr-frame|<tuple|scale|1cm|<tuple|0.5gw|0.5gh>>|gr-geometry|<tuple|geometry|1par|0.526078par|center>|gr-text-at-halign|center|gr-text-at-valign|center|gr-fill-color|pastel
      blue|<graphics||<point|-0.5|4>|<point|-1.5|4>|<point|-2.5|4>|<point|-3.5|4>|<point|-4.5|4>|<point|-5.5|4>|<point|-6.5|4>|<point|-7.5|4>|<with|color|red|<line|<point|1.5|3.0>|<point|1.5|4.0>>>|<point|0.5|4>|<point|1.5|4>|<point|2.5|4>|<point|3.5|4>|<point|4.5|4>|<point|5.5|4>|<point|6.5|4>|<point|7.5|4>|<line|<point|-7.5|4>|<point|-7.5|3.0>>|<line|<point|-7.5|4>|<point|-6.5|3.0>>|<line|<point|-6.5|4>|<point|-6.5|3.0>>|<line|<point|-6.5|4>|<point|-7.5|3.0>>|<line|<point|-5.5|4>|<point|-5.5|3.0>>|<line|<point|-5.5|4>|<point|-4.5|3.0>>|<line|<point|-4.5|4>|<point|-4.5|3.0>>|<line|<point|-4.5|4>|<point|-5.5|3.0>>|<line|<point|-3.5|4>|<point|-3.5|3.0>|<point|-2.5|4.0>|<point|-2.5|3.0>|<point|-3.5|4.0>>|<line|<point|-1.5|4>|<point|-1.5|3.0>|<point|-0.5|4.0>|<point|-0.5|3.0>|<point|-1.5|4.0>>|<line|<point|2.5|4>|<point|2.5|3.0>|<point|3.5|4.0>|<point|3.5|3.0>|<point|2.5|4.0>>|<line|<point|4.5|4>|<point|4.5|3.0>|<point|5.5|4.0>|<point|5.5|3.0>|<point|4.5|4.0>>|<line|<point|6.5|4>|<point|6.5|3.0>|<point|7.5|4.0>|<point|7.5|3.0>|<point|6.5|4.0>>|<with|fill-color|pastel
      blue|<cline|<point|-8|3>|<point|-8.0|2.0>|<point|8.0|2.0>|<point|8.0|3.0>>>|<line|<point|6.5|2.0>|<point|6.5|1.0>|<point|7.5|2.0>|<point|7.5|1.0>|<point|6.5|2.0>>|<line|<point|2.5|2.0>|<point|2.5|1.0>|<point|3.5|2.0>|<point|3.5|1.0>|<point|2.5|2.0>>|<line|<point|4.5|2.0>|<point|4.5|1.0>|<point|5.5|2.0>|<point|5.5|1.0>|<point|4.5|2.0>>|<line|<point|-1.5|2.0>|<point|-1.5|1.0>|<point|-0.5|2.0>|<point|-0.5|1.0>|<point|-1.5|2.0>>|<line|<point|-4.5|2.0>|<point|-4.5|1.0>>|<line|<point|-3.5|2.0>|<point|-3.5|1.0>|<point|-2.5|2.0>|<point|-2.5|1.0>|<point|-3.5|2.0>>|<line|<point|-5.5|2.0>|<point|-4.5|1.0>>|<line|<point|-4.5|2.0>|<point|-5.5|1.0>>|<line|<point|-5.5|2.0>|<point|-5.5|1.0>>|<line|<point|-6.5|2.0>|<point|-6.5|1.0>>|<line|<point|-7.5|2.0>|<point|-6.5|1.0>>|<line|<point|-6.5|2.0>|<point|-7.5|1.0>>|<line|<point|-7.5|2.0>|<point|-7.5|1.0>>|<with|fill-color|pastel
      blue|<cline|<point|-8.0|1.0>|<point|-8.0|0.0>|<point|8.0|0.0>|<point|8.0|1.0>>>|<line|<point|6.5|0.0>|<point|6.5|-1.0>|<point|7.5|0.0>|<point|7.5|-1.0>|<point|6.5|0.0>>|<line|<point|4.5|0.0>|<point|4.5|-1.0>|<point|5.5|0.0>|<point|5.5|-1.0>|<point|4.5|0.0>>|<line|<point|2.5|0.0>|<point|2.5|-1.0>|<point|3.5|0.0>|<point|3.5|-1.0>|<point|2.5|0.0>>|<line|<point|-1.5|0.0>|<point|-1.5|-1.0>|<point|-0.5|0.0>|<point|-0.5|-1.0>|<point|-1.5|0.0>>|<line|<point|-3.5|0.0>|<point|-3.5|-1.0>|<point|-2.5|0.0>|<point|-2.5|-1.0>|<point|-3.5|0.0>>|<line|<point|-4.5|0.0>|<point|-4.5|-1.0>>|<line|<point|-5.5|0.0>|<point|-4.5|-1.0>>|<line|<point|-4.5|0.0>|<point|-5.5|-1.0>>|<line|<point|-5.5|0.0>|<point|-5.5|-1.0>>|<line|<point|-6.5|0.0>|<point|-6.5|-1.0>>|<line|<point|-7.5|0.0>|<point|-6.5|-1.0>>|<line|<point|-6.5|0.0>|<point|-7.5|-1.0>>|<line|<point|-7.5|0.0>|<point|-7.5|-1.0>>|<with|fill-color|pastel
      blue|<cline|<point|-8.0|-1.0>|<point|-8.0|-2.0>|<point|8.0|-2.0>|<point|8.0|-1.0>>>|<line|<point|6.5|-2.0>|<point|6.5|-3.0>|<point|7.5|-2.0>|<point|7.5|-3.0>|<point|6.5|-2.0>>|<line|<point|4.5|-2.0>|<point|4.5|-3.0>|<point|5.5|-2.0>|<point|5.5|-3.0>|<point|4.5|-2.0>>|<line|<point|2.5|-2.0>|<point|2.5|-3.0>|<point|3.5|-2.0>|<point|3.5|-3.0>|<point|2.5|-2.0>>|<line|<point|-1.5|-2.0>|<point|-1.5|-3.0>|<point|-0.5|-2.0>|<point|-0.5|-3.0>|<point|-1.5|-2.0>>|<line|<point|-3.5|-2.0>|<point|-3.5|-3.0>|<point|-2.5|-2.0>|<point|-2.5|-3.0>|<point|-3.5|-2.0>>|<line|<point|-4.5|-2.0>|<point|-4.5|-3.0>>|<line|<point|-5.5|-2.0>|<point|-4.5|-3.0>>|<line|<point|-4.5|-2.0>|<point|-5.5|-3.0>>|<line|<point|-5.5|-2.0>|<point|-5.5|-3.0>>|<line|<point|-6.5|-2.0>|<point|-6.5|-3.0>>|<line|<point|-7.5|-2.0>|<point|-6.5|-3.0>>|<line|<point|-6.5|-2.0>|<point|-7.5|-3.0>>|<line|<point|-7.5|-2.0>|<point|-7.5|-3.0>>|<point|-7.5|-3>|<point|-6.5|-3>|<point|-5.5|-3>|<point|-4.5|-3>|<point|-3.5|-3>|<point|-2.5|-3>|<point|-1.5|-3>|<point|-0.5|-3>|<point|0.5|-3>|<point|1.5|-3>|<point|2.5|-3>|<point|3.5|-3>|<point|4.5|-3>|<point|5.5|-3>|<point|6.5|-3>|<point|7.5|-3>|<with|text-at-valign|center|text-at-halign|center|<text-at|Permutation
      + twiddle|<point|-4.0|2.5>>>|<with|text-at-valign|center|text-at-halign|center|<text-at|Permutation
      + twiddle|<point|-4.0|0.5>>>|<with|text-at-valign|center|text-at-halign|center|<text-at|Permutation
      + twiddle|<point|-4.0|-1.5>>>|<with|color|red|<line|<point|1.5|1.0>|<point|1.5|2.0>>>|<with|color|red|<line|<point|1.47936234951713|-1.0>|<point|1.47936234951713|0.0>>>|<with|color|red|<line|<point|1.5|-3.0>|<point|1.5|-2.0>>>|<with|color|red|<line|<point|1.5|4>|<point|0.5|3.0>>>|<with|color|red|<line|<point|1.5|2>|<point|0.5|1.0>>>|<with|color|red|<line|<point|1.5|-2>|<point|0.5|-3.0>>>|<with|opacity|50%|<line|<point|1.5|3>|<point|0.5|4.0>|<point|0.5|3.0>>>|<with|opacity|50%|<line|<point|1.5|1>|<point|0.5|2.0>|<point|0.5|1.0>>>|<with|color|red|<line|<point|1.47936234951713|0.0>|<point|0.5|-1.0>>>|<with|opacity|50%|<line|<point|1.47936|-1>|<point|0.5|0.0>|<point|0.5|-1.0>>>|<with|opacity|50%|<line|<point|1.5|-3>|<point|0.5|-2.0>|<point|0.5|-3.0>>>|<with|color|red|text-at-valign|center|text-at-halign|center|<math-at|<small|<with|color|red|1>>|<point|1.0|1.75>>>|<with|color|red|text-at-valign|center|text-at-halign|center|<math-at|<small|<with|color|red|-1>>|<point|1.75|1.5>>>|<with|color|red|text-at-valign|center|text-at-halign|center|<math-at|<small|<with|color|red|1>>|<point|1.0|3.75>>>|<with|color|red|text-at-valign|center|text-at-halign|center|<math-at|<small|<with|color|red|-1>>|<point|1.75|3.5>>>|<with|color|red|text-at-valign|center|text-at-halign|center|<math-at|<small|<with|color|red|1>>|<point|1.0|-0.25>>>|<with|color|red|text-at-valign|center|text-at-halign|center|<math-at|<small|<with|color|red|-1>>|<point|1.75|-0.5>>>|<with|color|red|text-at-valign|center|text-at-halign|center|<math-at|<small|<with|color|red|-1>>|<point|1.75|-2.5>>>|<with|color|red|text-at-valign|center|text-at-halign|center|<math-at|<small|<with|color|red|1>>|<point|1.0|-2.25>>>>>
    </hidden>|<\hidden>
      <with|gr-mode|<tuple|edit|point>|gr-frame|<tuple|scale|1cm|<tuple|0.500006gw|0.499999gh>>|gr-geometry|<tuple|geometry|1par|0.526078par|center>|gr-text-at-halign|center|gr-text-at-valign|center|gr-grid|<tuple|empty>|gr-grid-old|<tuple|cartesian|<point|0|0>|1>|gr-edit-grid-aspect|<tuple|<tuple|axes|none>|<tuple|1|none>|<tuple|10|none>>|gr-edit-grid|<tuple|empty>|gr-edit-grid-old|<tuple|cartesian|<point|0|0>|1>|gr-color|dark
      grey|<graphics||<with|fill-color|pastel
      blue|<cline|<point|-8.0|1.0>|<point|-8.0|0.0>|<point|8.0|0.0>|<point|8.0|1.0>>>|<with|text-at-valign|center|text-at-halign|center|<text-at|Permutation
      + twiddle|<point|-4.0|0.5>>>|<line|<point|-7.5|-1.5>|<point|-7.5|-3.0>>|<line|<point|-6.5|-1.5>|<point|-7.5|-3.0>>|<spline|<point|-7.5|-1.5>|<point|-6.25|-0.75>|<point|-5.5|8.32667268468867e-17>>|<line|<point|-7.5|-1.5>|<point|-6.5|-3.0>>|<line|<point|-6.5|-1.5>|<point|-6.5|-3.0>>|<line|<point|-7.5|8.32667268468867e-17>|<point|-7.5|-1.5>>|<line|<point|-5.5|-1.5>|<point|-5.5|-3.0>>|<line|<point|-4.5|-1.5>|<point|-5.5|-3.0>>|<spline|<point|-6.5|-1.5>|<point|-5.25|-0.75>|<point|-4.5|8.32667268468867e-17>>|<line|<point|-5.5|-1.5>|<point|-4.5|-3.0>>|<line|<point|-4.5|-1.5>|<point|-4.5|-3.0>>|<line|<point|-6.5|8.32667268468867e-17>|<point|-6.5|-1.5>>|<spline|<point|-7.5|8.32667268468867e-17>|<point|-6.25|-0.75>|<point|-5.5|-1.5>>|<spline|<point|-6.5|8.32667268468867e-17>|<point|-5.25|-0.75>|<point|-4.5|-1.5>>|<line|<point|-5.5|8.32667268468867e-17>|<point|-5.5|-1.5>>|<line|<point|-4.5|8.32667268468867e-17>|<point|-4.5|-1.5>>|<with|fill-color|pastel
      blue|<point|-7.5|-3.0>>|<point|-6.5|-3.0>|<point|-5.5|-3.0>|<point|-4.5|-3.0>|<line|<point|-0.5|-8.32667268468867e-17>|<point|-0.5|-1.5>>|<spline|<point|-2.5|-8.32667268468867e-17>|<point|-1.25|-0.75>|<point|-0.5|-1.5>>|<line|<point|-0.5|-1.5>|<point|-0.5|-3.0>>|<point|-0.5|-3.0>|<spline|<point|-3.5|-8.32667268468867e-17>|<point|-2.25|-0.75>|<point|-1.5|-1.5>>|<line|<point|-1.5|-8.32667268468867e-17>|<point|-1.5|-1.5>>|<line|<point|-1.5|-1.5>|<point|-0.5|-3.0>>|<line|<point|-1.5|-1.5>|<point|-1.5|-3.0>>|<line|<point|-0.5|-1.5>|<point|-1.5|-3.0>>|<point|-1.5|-3.0>|<spline|<point|-2.5|-1.5>|<point|-1.25|-0.75>|<point|-0.5|-8.32667268468867e-17>>|<line|<point|-2.5|-8.32667268468867e-17>|<point|-2.5|-1.5>>|<spline|<point|-3.5|-1.5>|<point|-2.25|-0.75>|<point|-1.5|-8.32667268468867e-17>>|<line|<point|-3.5|-8.32667268468867e-17>|<point|-3.5|-1.5>>|<line|<point|-2.5|-1.5>|<point|-2.5|-3.0>>|<point|-2.5|-3.0>|<line|<point|-3.5|-1.5>|<point|-2.5|-3.0>>|<line|<point|-3.5|-1.5>|<point|-3.5|-3.0>>|<line|<point|-2.5|-1.5>|<point|-3.5|-3.0>>|<with|fill-color|pastel
      blue|<point|-3.5|-3.0>>|<line|<point|7.5|8.32667268468867e-17>|<point|7.5|-1.5>>|<spline|<point|5.5|8.32667268468867e-17>|<point|6.75|-0.75>|<point|7.5|-1.5>>|<line|<point|7.5|-1.5>|<point|7.5|-3.0>>|<point|7.5|-3.0>|<spline|<point|4.5|8.32667268468867e-17>|<point|5.75|-0.75>|<point|6.5|-1.5>>|<line|<point|6.5|8.32667268468867e-17>|<point|6.5|-1.5>>|<line|<point|6.5|-1.5>|<point|7.5|-3.0>>|<line|<point|6.5|-1.5>|<point|6.5|-3.0>>|<line|<point|7.5|-1.5>|<point|6.5|-3.0>>|<point|6.5|-3.0>|<spline|<point|5.5|-1.5>|<point|6.75|-0.75>|<point|7.5|8.32667268468867e-17>>|<line|<point|5.5|8.32667268468867e-17>|<point|5.5|-1.5>>|<spline|<point|4.5|-1.5>|<point|5.75|-0.75>|<point|6.5|8.32667268468867e-17>>|<line|<point|4.5|8.32667268468867e-17>|<point|4.5|-1.5>>|<line|<point|5.5|-1.5>|<point|5.5|-3.0>>|<point|5.5|-3.0>|<line|<point|4.5|-1.5>|<point|5.5|-3.0>>|<line|<point|4.5|-1.5>|<point|4.5|-3.0>>|<line|<point|5.5|-1.5>|<point|4.5|-3.0>>|<with|fill-color|pastel
      blue|<point|4.5|-3.0>>|<line|<point|-4.5|4.0>|<point|-4.5|2.5>>|<spline|<point|-6.5|4.0>|<point|-5.25|3.25>|<point|-4.5|2.5>>|<line|<point|-4.5|2.5>|<point|-4.5|1.0>>|<spline|<point|-7.5|4.0>|<point|-6.25|3.25>|<point|-5.5|2.5>>|<line|<point|-5.5|4.0>|<point|-5.5|2.5>>|<line|<point|-5.5|2.5>|<point|-4.5|1.0>>|<line|<point|-5.5|2.5>|<point|-5.5|1.0>>|<line|<point|-4.5|2.5>|<point|-5.5|1.0>>|<spline|<point|-6.5|2.5>|<point|-5.25|3.25>|<point|-4.5|4.0>>|<line|<point|-6.5|4.0>|<point|-6.5|2.5>>|<spline|<point|-7.5|2.5>|<point|-6.25|3.25>|<point|-5.5|4.0>>|<line|<point|-7.5|4.0>|<point|-7.5|2.5>>|<line|<point|-6.5|2.5>|<point|-6.5|1.0>>|<line|<point|-7.5|2.5>|<point|-6.5|1.0>>|<line|<point|-7.5|2.5>|<point|-7.5|1.0>>|<line|<point|-6.5|2.5>|<point|-7.5|1.0>>|<with|fill-color|pastel
      blue|<point|-7.5|4.0>>|<point|-6.5|4.0>|<point|-5.5|4.0>|<point|-4.5|4.0>|<point|-0.5|4.0>|<point|-1.5|4.0>|<line|<point|-0.5|4.0>|<point|-0.5|2.5>>|<point|-2.5|4.0>|<spline|<point|-2.5|4.0>|<point|-1.25|3.25>|<point|-0.5|2.5>>|<line|<point|-0.5|2.5>|<point|-0.5|1.0>>|<with|fill-color|pastel
      blue|<point|-3.5|4.0>>|<spline|<point|-3.5|4.0>|<point|-2.25|3.25>|<point|-1.5|2.5>>|<line|<point|-1.5|4.0>|<point|-1.5|2.5>>|<line|<point|-1.5|2.5>|<point|-0.5|1.0>>|<line|<point|-1.5|2.5>|<point|-1.5|1.0>>|<line|<point|-0.5|2.5>|<point|-1.5|1.0>>|<spline|<point|-2.5|2.5>|<point|-1.25|3.25>|<point|-0.5|4.0>>|<line|<point|-2.5|4.0>|<point|-2.5|2.5>>|<spline|<point|-3.5|2.5>|<point|-2.25|3.25>|<point|-1.5|4.0>>|<line|<point|-3.5|4.0>|<point|-3.5|2.5>>|<line|<point|-2.5|2.5>|<point|-2.5|1.0>>|<line|<point|-3.5|2.5>|<point|-2.5|1.0>>|<line|<point|-3.5|2.5>|<point|-3.5|1.0>>|<line|<point|-2.5|2.5>|<point|-3.5|1.0>>|<point|7.5|4.0>|<point|6.5|4.0>|<line|<point|7.5|4.0>|<point|7.5|2.5>>|<point|5.5|4.0>|<spline|<point|5.5|4.0>|<point|6.75|3.25>|<point|7.5|2.5>>|<line|<point|7.5|2.5>|<point|7.5|1.0>>|<with|fill-color|pastel
      blue|<point|4.5|4.0>>|<spline|<point|4.5|4.0>|<point|5.75|3.25>|<point|6.5|2.5>>|<line|<point|6.5|4.0>|<point|6.5|2.5>>|<line|<point|6.5|2.5>|<point|7.5|1.0>>|<line|<point|6.5|2.5>|<point|6.5|1.0>>|<line|<point|7.5|2.5>|<point|6.5|1.0>>|<spline|<point|5.5|2.5>|<point|6.75|3.25>|<point|7.5|4.0>>|<line|<point|5.5|4.0>|<point|5.5|2.5>>|<spline|<point|4.5|2.5>|<point|5.75|3.25>|<point|6.5|4.0>>|<line|<point|4.5|4.0>|<point|4.5|2.5>>|<line|<point|5.5|2.5>|<point|5.5|1.0>>|<line|<point|4.5|2.5>|<point|5.5|1.0>>|<line|<point|4.5|2.5>|<point|4.5|1.0>>|<line|<point|5.5|2.5>|<point|4.5|1.0>>|<with|color|dark
      grey|<line|<point|1.5|2.5>|<point|1.5|1.0>>>|<with|color|dark
      grey|<line|<point|0.5|4.0>|<point|0.5|2.5>>>|<with|color|dark
      grey|<spline|<point|0.5|2.5>|<point|1.75|3.25>|<point|2.5|4.0>>>|<with|color|red|<spline|<point|1.5|2.5>|<point|2.75|3.25>|<point|3.5|4.0>>>|<with|color|red|<line|<point|3.5|2.5>|<point|2.5|1.0>>>|<with|color|dark
      grey|<line|<point|2.5|2.5>|<point|2.5|1.0>>>|<with|color|dark
      grey|<line|<point|2.5|2.5>|<point|3.5|1.0>>>|<with|color|dark
      grey|<line|<point|2.5|4.0>|<point|2.5|2.5>>>|<with|color|dark
      grey|<spline|<point|0.5|4.0>|<point|1.75|3.25>|<point|2.5|2.5>>>|<with|color|red|text-at-valign|center|text-at-halign|center|<math-at|<small|<with|color|red|\<mathi\>>>|<point|3.0|2.3>>>|<with|color|red|<line|<point|3.5|2.5>|<point|3.5|1.0>>>|<with|color|dark
      grey|<spline|<point|1.5|4.0>|<point|2.75|3.25>|<point|3.5|2.5>>>|<with|color|red|<line|<point|3.5|4.0>|<point|3.5|2.5>>>|<with|color|red|text-at-valign|center|text-at-halign|center|<math-at|<small|<with|color|red|-\<mathi\>>>|<point|4.0|1.6>>>|<with|color|red|text-at-valign|center|text-at-halign|center|<math-at|<small|<with|color|red|1>>|<point|3.0|3.8>>>|<with|color|red|text-at-valign|center|text-at-halign|center|<math-at|<small|<with|color|red|-1>>|<point|4.0|3.3>>>|<with|color|dark
      grey|<line|<point|1.5|4.0>|<point|1.5|2.5>>>|<with|color|dark
      grey|<line|<point|0.5|2.5>|<point|1.5|1.0>>>|<with|color|dark
      grey|<line|<point|0.5|2.5>|<point|0.5|1.0>>>|<with|color|dark
      grey|<line|<point|1.5|2.5>|<point|0.5|1.0>>>|<with|color|dark
      grey|<line|<point|1.5|-1.5>|<point|0.5|-3.0>>>|<with|color|dark
      grey|<line|<point|0.5|-1.5>|<point|0.5|-3.0>>>|<with|color|dark
      grey|<line|<point|0.5|-1.5>|<point|1.5|-3.0>>>|<with|color|dark
      grey|<line|<point|1.5|-1.5>|<point|1.5|-3.0>>>|<with|color|dark
      grey|<line|<point|0.5|0.0>|<point|0.5|-1.5>>>|<with|color|dark
      grey|<spline|<point|0.5|-1.5>|<point|1.75|-0.75>|<point|2.5|0.0>>>|<with|color|dark
      grey|<line|<point|1.5|0.0>|<point|1.5|-1.5>>>|<with|color|red|<spline|<point|1.5|-1.5>|<point|2.75|-0.75>|<point|3.5|0.0>>>|<with|color|red|<line|<point|3.5|-1.5>|<point|2.5|-3.0>>>|<with|color|dark
      grey|<line|<point|2.5|-1.5>|<point|2.5|-3.0>>>|<with|color|dark
      grey|<line|<point|2.5|-1.5>|<point|3.5|-3.0>>>|<with|color|dark
      grey|<line|<point|2.5|0.0>|<point|2.5|-1.5>>>|<with|color|dark
      grey|<spline|<point|0.5|0.0>|<point|1.75|-0.75>|<point|2.5|-1.5>>>|<with|color|red|text-at-valign|center|text-at-halign|center|<math-at|<small|<with|color|red|\<mathi\>>>|<point|3.0|-1.7>>>|<with|color|red|<line|<point|3.5|-1.5>|<point|3.5|-3.0>>>|<with|color|dark
      grey|<spline|<point|1.5|0.0>|<point|2.75|-0.75>|<point|3.5|-1.5>>>|<with|color|red|<line|<point|3.5|0.0>|<point|3.5|-1.5>>>|<with|color|red|text-at-valign|center|text-at-halign|center|<math-at|<small|<with|color|red|-\<mathi\>>>|<point|4.0|-2.4>>>|<with|color|red|text-at-valign|center|text-at-halign|center|<math-at|<small|<with|color|red|1>>|<point|3.0|-0.2>>>|<with|color|red|text-at-valign|center|text-at-halign|center|<math-at|<small|<with|color|red|-1>>|<point|4.0|-0.7>>>|<with|color|dark
      grey|<point|0.5|4>>|<with|color|dark
      grey|<point|1.6|4>>|<with|color|dark
      grey|<point|2.4|4>>|<with|color|dark
      grey|<point|3.5|4>>|<with|color|dark
      grey|<point|0.5|-3>>|<with|color|dark
      grey|<point|1.5|-3>>|<with|color|dark
      grey|<point|2.5|-3>>|<with|color|dark grey|<point|3.4|-3>>>>
    </hidden>>
  </hidden>|<\hidden>
    <tit|Giant butterflies>

    <with|gr-mode|<tuple|edit|spline>|gr-frame|<tuple|scale|1.18933cm|<tuple|0.534985gw|0.304451gh>>|gr-geometry|<tuple|geometry|1par|0.582555par|center>|gr-text-at-halign|right|gr-text-at-valign|center|magnify|1.18920711391541|<graphics||<with|text-at-valign|center|text-at-halign|center|<text-at|<image|butterfly.png|2cm|||>|<point|-0.91602725228205|1.41308374123562>>>|<with|text-at-valign|center|text-at-halign|center|<text-at|<image|butterfly.png|2cm|||>|<point|-2.97946156899061|1.42766900383648>>>|<with|text-at-valign|center|text-at-halign|center|<text-at|<image|butterfly.png|2cm|||>|<point|-4.94461899722185|1.49186400317503>>>|<with|text-at-valign|center|text-at-halign|center|<text-at|<image|butterfly.png|2cm|||>|<point|-4.9141878995899|-1.46738466860694>>>|<with|text-at-valign|center|text-at-halign|center|<text-at|<image|butterfly.png|2cm|||>|<point|-6.98696870392909|-1.53085312475194>>>|<with|text-at-valign|center|text-at-halign|center|<text-at|<image|butterfly.png|2cm|||>|<point|-2.95493735057547|-1.44701266966529>>>|<with|text-at-valign|center|text-at-halign|center|<text-at|<image|butterfly.png|2cm|||>|<point|-0.99568348101601|-1.42663960444502>>>|<with|text-at-valign|center|text-at-halign|center|<text-at|<image|butterfly.png|2cm|||>|<point|-7.0015694434449|4.53552350840059>>>|<with|text-at-valign|center|text-at-halign|center|<text-at|<image|butterfly.png|2cm|||>|<point|-5.0|4.5>>>|<with|text-at-valign|center|text-at-halign|center|<text-at|<image|butterfly.png|2cm|||>|<point|-3.0|4.5>>>|<with|text-at-valign|center|text-at-halign|center|<text-at|<image|butterfly.png|2cm|||>|<point|-1.0|4.5>>>|<with|text-at-valign|center|text-at-halign|center|<text-at|<image|butterfly.png|2cm|||>|<point|-7.0|1.5>>>|<with|text-at-valign|center|text-at-halign|center|<text-at|<image|butterfly.png|2cm|||>|<point|1.0|4.5>>>|<with|text-at-valign|center|text-at-halign|center|<text-at|<image|butterfly.png|2cm|||>|<point|3.0|4.5>>>|<with|text-at-valign|center|text-at-halign|center|<text-at|<image|butterfly.png|2cm|||>|<point|5.0|4.5>>>|<with|text-at-valign|center|text-at-halign|center|<text-at|<image|butterfly.png|2cm|||>|<point|7.0|4.5>>>|<with|text-at-valign|center|text-at-halign|center|<text-at|<image|butterfly.png|2cm|||>|<point|1.0|-1.5>>>|<with|text-at-valign|center|text-at-halign|center|<text-at|<image|butterfly.png|2cm|||>|<point|3.0|-1.5>>>|<with|text-at-valign|center|text-at-halign|center|<text-at|<image|butterfly.png|2cm|||>|<point|5.0|-1.5>>>|<with|text-at-valign|center|text-at-halign|center|<text-at|<image|butterfly.png|2cm|||>|<point|7.0|-1.5>>>|<with|text-at-valign|center|text-at-halign|center|<text-at|<image|butterfly.png|2cm|||>|<point|7.0|1.5>>>|<with|text-at-valign|center|text-at-halign|center|<text-at|<image|butterfly.png|2cm|||>|<point|5.0|1.5>>>|<with|text-at-valign|center|text-at-halign|center|<text-at|<image|butterfly.png|2cm|||>|<point|3.0|1.5>>>|<with|text-at-valign|center|text-at-halign|center|<text-at|<image|butterfly.png|2cm|||>|<point|1.0|1.5>>>|<point|-7.75|6>|<point|-7.25|6>|<point|-6.75|6>|<point|-6.25|6>|<point|-5.75|6>|<point|-5.25|6>|<point|-4.75|6>|<point|-4.25|6>|<point|-3.75|6>|<point|-3.25|6>|<point|-2.75|6>|<point|-2.25|6>|<point|-1.75|6>|<point|-1.25|6>|<point|-0.75|6>|<point|-0.25|6>|<point|0.25|6>|<point|0.75|6>|<point|1.25|6>|<point|1.75|6>|<point|2.25|6>|<point|2.75|6>|<point|3.25|6>|<point|3.75|6>|<point|4.25|6>|<point|4.75|6>|<point|5.25|6>|<point|5.75|6>|<point|6.25|6>|<point|6.75|6>|<point|7.25|6>|<point|7.75|6>|<line|<point|-7.75|-2.30501541725267>|<point|-7.75|-3.0>>|<line|<point|-7.25|-2.30267047427459>|<point|-7.25|-3.0>>|<line|<point|-6.75|-2.30032553129652>|<point|-6.75|-3.0>>|<line|<point|-6.25|-2.29798058831844>|<point|-6.25|-3.0>>|<line|<point|-5.75|-2.29563564534036>|<point|-5.75|-3.0>>|<line|<point|-5.25|-2.29329070236228>|<point|-5.25|-3.0>>|<line|<point|-4.75|-2.29094575938421>|<point|-4.75|-3.0>>|<line|<point|-4.25|-2.28860081640613>|<point|-4.25|-3.0>>|<line|<point|-3.75|-2.28625587342805>|<point|-3.75|-3.0>>|<line|<point|-3.25|-2.28391093044997>|<point|-3.25|-3.0>>|<line|<point|-2.75|-2.2815659874719>|<point|-2.75|-3.0>>|<line|<point|-2.25|-2.27922104449382>|<point|-2.25|-3.0>>|<line|<point|-1.75|-2.27687610151574>|<point|-1.75|-3.0>>|<line|<point|-1.25|-2.27453115853766>|<point|-1.25|-3.0>>|<line|<point|-0.75|-2.27218621555958>|<point|-0.75|-3.0>>|<line|<point|-0.25|-2.26984127258151>|<point|-0.249999999999999|-3.0>>|<line|<point|0.25|-2.26749632960343>|<point|0.25|-3.01696973433462>>|<line|<point|0.75|-2.26515138662535>|<point|0.75|-3.01696973433462>>|<line|<point|1.25|-2.26280644364727>|<point|1.25|-3.01696973433462>>|<line|<point|1.75|-2.2604615006692>|<point|1.75|-3.01696973433462>>|<line|<point|2.25|-2.25811655769112>|<point|2.25|-3.01696973433462>>|<line|<point|2.75|-2.25577161471304>|<point|2.75|-3.01696973433462>>|<line|<point|3.25|-2.25342667173496>|<point|3.25|-3.01696973433462>>|<line|<point|3.75|-2.25108172875689>|<point|3.75|-3.01696973433462>>|<line|<point|4.25|-2.25>|<point|4.25|-3.01696973433462>>|<line|<point|4.75|-2.25>|<point|4.75|-3.01696973433462>>|<line|<point|5.25|-2.24404689982265>|<point|5.25|-3.01696973433462>>|<line|<point|5.75|-2.25>|<point|5.75|-3.01696973433462>>|<line|<point|6.25|-2.25>|<point|6.25|-3.01696973433462>>|<line|<point|6.75|-2.25>|<point|6.75|-3.01696973433462>>|<line|<point|7.25|-2.25>|<point|7.25|-3.01696973433462>>|<line|<point|7.75|-2.25>|<point|7.75|-3.01696973433462>>|<line|<point|7.75|3.78049026359429>|<point|7.75|3.28049026359429>>|<line|<point|7.25|3.78049026359429>|<point|7.25|3.28049026359429>>|<line|<point|6.75|3.78049026359429>|<point|6.75|3.28049026359429>>|<line|<point|6.25|3.78049026359429>|<point|6.25|3.28049026359429>>|<line|<point|5.75|3.78049026359429>|<point|5.75|3.28049026359429>>|<line|<point|5.25|3.78049026359429>|<point|5.25|3.28049026359429>>|<line|<point|4.75|3.78049026359429>|<point|4.75|3.28049026359429>>|<line|<point|4.25|3.78049026359429>|<point|4.25|3.28049026359429>>|<line|<point|3.75|3.78049026359429>|<point|3.75|3.28049026359429>>|<line|<point|3.25|3.78049026359429>|<point|3.25|3.28049026359429>>|<line|<point|2.75|3.78049026359429>|<point|2.75|3.28049026359429>>|<line|<point|2.25|3.78049026359429>|<point|2.25|3.28049026359429>>|<line|<point|1.75|3.78049026359429>|<point|1.75|3.28049026359429>>|<line|<point|1.25|3.78049026359429>|<point|1.25|3.28049026359429>>|<line|<point|0.75|3.78049026359429>|<point|0.75|3.28049026359429>>|<line|<point|0.25|3.78049026359429>|<point|0.25|3.28049026359429>>|<line|<point|0.25|0.77619323872997>|<point|0.25|0.27619323872997>>|<line|<point|0.75|0.77619323872997>|<point|0.75|0.27619323872997>>|<line|<point|1.25|0.77619323872997>|<point|1.25|0.27619323872997>>|<line|<point|1.75|0.77619323872997>|<point|1.75|0.27619323872997>>|<line|<point|2.25|0.77619323872997>|<point|2.25|0.27619323872997>>|<line|<point|2.75|0.77619323872997>|<point|2.75|0.27619323872997>>|<line|<point|3.25|0.77619323872997>|<point|3.25|0.27619323872997>>|<line|<point|3.75|0.77619323872997>|<point|3.75|0.27619323872997>>|<line|<point|4.25|0.77619323872997>|<point|4.25|0.27619323872997>>|<line|<point|4.75|0.77619323872997>|<point|4.75|0.27619323872997>>|<line|<point|5.25|0.77619323872997>|<point|5.25|0.27619323872997>>|<line|<point|5.75|0.77619323872997>|<point|5.75|0.27619323872997>>|<line|<point|6.25|0.77619323872997>|<point|6.25|0.27619323872997>>|<line|<point|6.75|0.77619323872997>|<point|6.75|0.27619323872997>>|<line|<point|7.25|0.77619323872997>|<point|7.25|0.27619323872997>>|<line|<point|7.75|0.77619323872997>|<point|7.75|0.27619323872997>>|<line|<point|7.75|2.75>|<point|7.75|2.25>>|<line|<point|7.25|2.75>|<point|7.25|2.25>>|<line|<point|6.75|2.75>|<point|6.75|2.25>>|<line|<point|6.25|2.75>|<point|6.25|2.25>>|<line|<point|5.75|2.75>|<point|5.75|2.25>>|<line|<point|5.25|2.75>|<point|5.25|2.25>>|<line|<point|4.75|2.75>|<point|4.75|2.25>>|<line|<point|4.25|2.75>|<point|4.25|2.25>>|<line|<point|3.75|2.75>|<point|3.75|2.25>>|<line|<point|3.25|2.75>|<point|3.25|2.25>>|<line|<point|2.75|2.75>|<point|2.75|2.25>>|<line|<point|2.25|2.75>|<point|2.25|2.25>>|<line|<point|1.75|2.75>|<point|1.75|2.25>>|<line|<point|1.25|2.75>|<point|1.25|2.25>>|<line|<point|0.75|2.75>|<point|0.75|2.25>>|<line|<point|0.25|2.75>|<point|0.25|2.25>>|<line|<point|7.75|-0.25>|<point|7.75|-0.75>>|<line|<point|7.25|-0.25>|<point|7.25|-0.75>>|<line|<point|6.75|-0.25>|<point|6.75|-0.75>>|<line|<point|6.25|-0.25>|<point|6.25|-0.75>>|<line|<point|5.75|-0.25>|<point|5.75|-0.75>>|<line|<point|5.25|-0.25>|<point|5.25|-0.75>>|<line|<point|4.75|-0.25>|<point|4.75|-0.75>>|<line|<point|4.25|-0.25>|<point|4.25|-0.75>>|<line|<point|3.75|-0.25>|<point|3.75|-0.75>>|<line|<point|3.25|-0.25>|<point|3.25|-0.75>>|<line|<point|2.75|-0.25>|<point|2.75|-0.75>>|<line|<point|2.25|-0.25>|<point|2.25|-0.75>>|<line|<point|1.75|-0.25>|<point|1.75|-0.75>>|<line|<point|1.25|-0.25>|<point|1.25|-0.75>>|<line|<point|0.75|-0.25>|<point|0.75|-0.75>>|<line|<point|0.25|-0.25>|<point|0.25|-0.75>>|<line|<point|-0.249999999999999|-0.25>|<point|-0.249999999999999|-0.75>>|<line|<point|-0.75|-0.25>|<point|-0.75|-0.75>>|<line|<point|-1.25|-0.25>|<point|-1.25|-0.75>>|<line|<point|-1.75|-0.25>|<point|-1.75|-0.75>>|<line|<point|-2.25|-0.25>|<point|-2.25|-0.75>>|<line|<point|-2.75|-0.25>|<point|-2.75|-0.75>>|<line|<point|-3.25|-0.25>|<point|-3.25|-0.75>>|<line|<point|-3.75|-0.25>|<point|-3.75|-0.75>>|<line|<point|-4.25|-0.25>|<point|-4.25|-0.75>>|<line|<point|-4.75|-0.25>|<point|-4.75|-0.75>>|<line|<point|-5.25|-0.25>|<point|-5.25|-0.75>>|<line|<point|-5.75|-0.25>|<point|-5.75|-0.75>>|<line|<point|-6.25|-0.25>|<point|-6.25|-0.75>>|<line|<point|-6.75|-0.25>|<point|-6.75|-0.75>>|<line|<point|-7.25|-0.25>|<point|-7.25|-0.75>>|<line|<point|-7.75|-0.25>|<point|-7.75|-0.75>>|<line|<point|-0.249999999999999|0.75>|<point|-0.249999999999999|0.25>>|<line|<point|-0.749999999999999|0.75>|<point|-0.749999999999999|0.25>>|<line|<point|-1.25|0.75>|<point|-1.25|0.25>>|<line|<point|-1.75|0.75>|<point|-1.75|0.25>>|<line|<point|-2.25|0.75>|<point|-2.25|0.25>>|<line|<point|-2.75|0.75>|<point|-2.75|0.25>>|<line|<point|-3.25|0.75>|<point|-3.25|0.25>>|<line|<point|-3.75|0.75>|<point|-3.75|0.25>>|<line|<point|-4.25|0.75>|<point|-4.25|0.25>>|<line|<point|-4.75|0.75>|<point|-4.75|0.25>>|<line|<point|-5.25|0.75>|<point|-5.25|0.25>>|<line|<point|-5.75|0.75>|<point|-5.75|0.25>>|<line|<point|-6.25|0.75>|<point|-6.25|0.25>>|<line|<point|-6.75|0.75>|<point|-6.75|0.25>>|<line|<point|-7.25|0.75>|<point|-7.25|0.25>>|<line|<point|-7.75|0.75>|<point|-7.75|0.25>>|<line|<point|-0.25|3.75>|<point|-0.25|3.25>>|<line|<point|-0.75|3.75>|<point|-0.75|3.25>>|<line|<point|-1.25|3.75>|<point|-1.25|3.25>>|<line|<point|-1.75|3.75>|<point|-1.75|3.25>>|<line|<point|-2.25|3.75>|<point|-2.25|3.25>>|<line|<point|-2.75|3.75>|<point|-2.75|3.25>>|<line|<point|-3.25|3.75>|<point|-3.25|3.25>>|<line|<point|-3.75|3.75>|<point|-3.75|3.25>>|<line|<point|-4.25|3.75>|<point|-4.25|3.25>>|<line|<point|-4.75|3.75>|<point|-4.75|3.25>>|<line|<point|-5.25|3.75>|<point|-5.25|3.25>>|<line|<point|-5.75|3.75>|<point|-5.75|3.25>>|<line|<point|-6.25|3.75>|<point|-6.25|3.25>>|<line|<point|-6.75|3.75>|<point|-6.75|3.25>>|<line|<point|-7.25|3.75>|<point|-7.25|3.25>>|<line|<point|-7.75|3.75>|<point|-7.75|3.25>>|<line|<point|-0.25|2.75>|<point|-0.25|2.25>>|<line|<point|-0.75|2.75>|<point|-0.75|2.25>>|<line|<point|-1.25|2.75>|<point|-1.25|2.25>>|<line|<point|-1.75|2.75>|<point|-1.75|2.25>>|<line|<point|-2.25|2.75>|<point|-2.25|2.25>>|<line|<point|-2.75|2.75>|<point|-2.75|2.25>>|<line|<point|-3.25|2.75>|<point|-3.25|2.25>>|<line|<point|-3.75|2.75>|<point|-3.75|2.25>>|<line|<point|-4.25|2.75>|<point|-4.25|2.25>>|<line|<point|-4.75|2.75>|<point|-4.75|2.25>>|<line|<point|-5.25|2.75>|<point|-5.25|2.25>>|<line|<point|-5.75|2.75>|<point|-5.75|2.25>>|<line|<point|-6.25|2.75>|<point|-6.25|2.25>>|<line|<point|-6.75|2.75>|<point|-6.75|2.25>>|<line|<point|-7.25|2.75>|<point|-7.25|2.25>>|<line|<point|-7.75|2.75>|<point|-7.75|2.25>>|<point|7.75|-3.0>|<point|7.25|-3.0>|<point|6.75|-3.0>|<point|6.25|-3.0>|<point|5.75|-3.0>|<point|5.25|-3.0>|<point|4.75|-3.0>|<point|4.25|-3.0>|<point|3.75|-3.0>|<point|3.25|-3.0>|<point|2.75|-3.0>|<point|2.25|-3.0>|<point|1.75|-3.0>|<point|1.25|-3.0>|<point|0.75|-3.0>|<point|0.249999999999999|-3.0>|<point|-0.250000000000001|-3.0>|<point|-0.75|-3.0>|<point|-1.25|-3.0>|<point|-1.75|-3.0>|<point|-2.25|-3.0>|<point|-2.75|-3.0>|<point|-3.25|-3.0>|<point|-3.75|-3.0>|<point|-4.25|-3.0>|<point|-4.75|-3.0>|<point|-5.25|-3.0>|<point|-5.75|-3.0>|<point|-6.25|-3.0>|<point|-6.75|-3.0>|<point|-7.25|-3.0>|<point|-7.75|-3.0>|<cline|<point|8.0|-2.25>|<point|8.0|-0.75>|<point|-8.0|-0.75>|<point|-8.0|-2.25>>|<line|<point|6|-2.25>|<point|6.0|-0.75>>|<line|<point|4|-2.25>|<point|4.0|-0.75>>|<line|<point|2|-2.25>|<point|2.0|-0.75>>|<line|<point|0|-2.25>|<point|0.0|-0.75>>|<line|<point|-2|-2.25>|<point|-2.0|-0.75>>|<line|<point|-2|0.75>|<point|-2.0|2.25>>|<line|<point|0|0.75>|<point|0.0|2.25>>|<line|<point|2|0.72892>|<point|2.0|2.25>>|<line|<point|4|0.75>|<point|4.0|2.25>>|<line|<point|6|0.75>|<point|6.0|2.25>>|<with|fill-color|pastel
    blue|<cline|<point|-8.0|0.25>|<point|-8.0|-0.25>|<point|8.0|-0.25>|<point|8.0|0.25>>>|<line|<point|-6|-2.25>|<point|-6.0|-0.75>>|<line|<point|-4|-2.25>|<point|-4.0|-0.75>>|<line|<point|-4|0.75>|<point|-4.0|2.25>>|<cline|<point|8.0|2.25>|<point|8.0|0.75>|<point|-8.0|0.75>|<point|-8.0|2.25>>|<line|<point|-6|0.75>|<point|-6.0|2.25>>|<line|<point|-7.75|6>|<point|-7.75|5.25>>|<line|<point|-7.25|6>|<point|-7.25|5.25>>|<line|<point|-6.75|6>|<point|-6.75|5.25>>|<line|<point|-6.25|6>|<point|-6.25|5.25>>|<line|<point|-5.75|6>|<point|-5.75|5.25>>|<line|<point|-5.25|6>|<point|-5.25|5.25>>|<line|<point|-4.75|6>|<point|-4.75|5.25>>|<line|<point|-4.25|6>|<point|-4.25|5.25>>|<line|<point|-3.75|6>|<point|-3.75|5.25>>|<line|<point|-6|5.25>|<point|-6.0|3.75251743617093>>|<line|<point|-4|5.25>|<point|-4.0|3.75503487234186>>|<line|<point|-2|5.25>|<point|-2.0|3.75755230851279>>|<line|<point|-3.25|6>|<point|-3.25|5.25>>|<line|<point|-2.75|6>|<point|-2.75|5.25>>|<line|<point|-2.25|6>|<point|-2.25|5.25>>|<line|<point|-1.75|6>|<point|-1.75|5.25>>|<line|<point|-1.25|6>|<point|-1.25|5.25>>|<line|<point|-0.75|6>|<point|-0.75|5.25>>|<line|<point|-0.25|6>|<point|-0.25|5.25>>|<line|<point|0.25|6>|<point|0.25|5.25>>|<line|<point|0|5.25>|<point|3.84987216161167e-15|3.76006974468371>>|<line|<point|2|5.25>|<point|2.0|3.76258718085464>>|<line|<point|0.75|6>|<point|0.75|5.25>>|<line|<point|1.25|6>|<point|1.25|5.25>>|<line|<point|1.75|6>|<point|1.75|5.25>>|<line|<point|2.25|6>|<point|2.25|5.25>>|<line|<point|2.75|6>|<point|2.75|5.25>>|<line|<point|3.25|6>|<point|3.25|5.25>>|<line|<point|3.75|6>|<point|3.75|5.25>>|<line|<point|4|5.25>|<point|4.0|3.75>>|<cline|<point|-8.0|5.25>|<point|8.0|5.25>|<point|8.0|3.75>|<point|-8.0|3.75>>|<line|<point|6|5.25>|<point|6.0|3.75>>|<line|<point|4.25|6>|<point|4.25|5.25>>|<line|<point|4.75|6>|<point|4.75|5.25>>|<line|<point|5.25|6>|<point|5.25|5.25>>|<line|<point|5.75|6>|<point|5.75|5.25>>|<line|<point|6.25|6>|<point|6.25|5.25>>|<line|<point|6.75|6>|<point|6.75|5.25>>|<line|<point|7.25|6>|<point|7.25|5.25>>|<line|<point|7.75|6>|<point|7.75|5.25>>|<with|fill-color|pastel
    blue|<cline|<point|-8.0|3.25>|<point|-8.0|2.75>|<point|8.0|2.75>|<point|8.0|3.25>>>|<with|color|dark
    blue|arrow-end|\<gtr\>|line-width|2ln|<spline|<point|0.25|3.25>|<point|-0.25|3.25>|<point|-0.5|3.0>|<point|-0.25|2.75>|<point|0.25|2.75>|<point|0.5|3.0>>>|<with|color|dark
    blue|arrow-end|\<gtr\>|line-width|2ln|<spline|<point|0.25|0.25>|<point|-0.25|0.25>|<point|-0.5|0.0>|<point|-0.25|-0.25>|<point|0.25|-0.25>|<point|0.5|0.0>>>|<spline|<point|-7.75|6.25>|<point|0.0|6.5>|<point|7.75|6.25>>|<spline|<point|-6.25|6.25>|<point|-7.0|6.5>|<point|-7.75|6.25>>|<with|text-at-valign|center|text-at-halign|center|<math-at|N|<point|0|7>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|R\<approx\>lg
    N|<point|-7|7>>>|<spline|<point|-8.25|5.25>|<point|-8.5|4.5>|<point|-8.25|3.75>>|<with|text-at-valign|center|text-at-halign|right|<math-at|lg
    lg N|<point|-8.73557097370726|3.97126013264554>>>|<with|text-at-valign|center|text-at-halign|right|<math-at|lg
    R\<approx\>|<point|-8.66705134800684|4.65645638964975>>>|<with|text-at-valign|center|text-at-halign|right|<math-at|lg
    N|<point|-8.75|1.5>>>|<spline|<point|-8.25|5.25>|<point|-8.55033995634099|1.49999304792759>|<point|-8.25|-2.25>>>>

    \;

    <pastel|Slightly cheating in picture: we should have used 16 butterflies
    on every line>
  </hidden>|<\hidden>
    <tit|Complexity analysis of fast integer multiplication>

    <\compact>
      <\itemize>
        <unroll|<\shown>
          <item>Cut <math|n>-bit integer in <math|N> chunks of
          <math|\<approx\>b/2> bits. Use <math|b>-bit working
          precision.<vspace|0.5fn>
        </shown>|<\hidden*>
          <item>Reduce FFT to giant butterflies of size <math|R\<times\>lg R>
          with <math|R\<approx\>b\<approx\>lg n><vspace|0.5fn>
        </hidden*>|<\hidden*>
          <item>Reduce giant butterflies back to integer
          multiplication:<vspace|0.25fn>

          <htab|5mm><metal|DFT of size <math|R\<times\>lg R> over
          <math|\<bbb-C\><rsub|b>> <math|<above|\<rightsquigarrow\>|Bluestein>>
          <math|O<around*|(|<math-ss|M><rsub|\<bbb-C\><rsub|b><around*|[|X|]>><around*|(|R|)>|)>>
          <math|<above|\<rightsquigarrow\>|Kronecker>>
          <math|O<around*|(|<math-ss|I><around*|(|R*b|)>|)>>><htab|5mm>

          <vspace*|0.25fn>(with respect to Frer's method: <with|color|dark
          red|Slower giant butterflies>, <with|color|dark green|but faster
          <em|twiddling>>)<vspace|0.5fn>
        </hidden*>|<\hidden*>
          <item>Cost of giant butterflies:

          <\eqnarray*>
            <tformat|<table|<row|<cell|<math-ss|C><rsub|1>>|<cell|=>|<cell|O<around*|(|<frac|N|R>*<frac|lg
            N|lg R>*<math-ss|I><around*|(|R*b|)>|)>.>>>>
          </eqnarray*>
        </hidden*>|<\hidden*>
          <item>Cost of twiddle factors:

          <\eqnarray*>
            <tformat|<table|<row|<cell|<math-ss|C><rsub|2>>|<cell|=>|<cell|O<around*|(|N*<frac|lg
            N|lg R>*<math-ss|I><around*|(|b|)>|)><space|1.2spc>=<space|1.2spc>O<around*|(|<frac|N|R>*<frac|lg
            N|lg R>*<math-ss|I><around*|(|R*b|)>|)>>>>>
          </eqnarray*>
        </hidden*>|<\hidden*>
          <item>Recursion:

          <\eqnarray*>
            <tformat|<table|<row|<cell|<frac|<math-ss|I><around*|(|n|)>|n*lg
            n>>|<cell|\<leqslant\>>|<cell|K*<frac|<math-ss|I><around*|(|R*b|)>|R*b*lg
            <around*|(|R*b|)>>+O<around*|(|1|)>.>>>>
          </eqnarray*>
        </hidden*>|<\hidden*>
          <item>Conclusion:

          <\eqnarray*>
            <tformat|<table|<row|<cell|<math-ss|I><around*|(|n|)>>|<cell|=>|<cell|O<around*|(|n*lg
            n*K<rsup|log<rsup|\<ast\>> n>|)>.>>>>
          </eqnarray*>
        </hidden*>>
      </itemize>
    </compact>
  </hidden>|<\hidden>
    <tit|Which approach yields the fastest algorithm?>

    <unroll|<\shown>
      <\compact>
        We now have several ways to show that

        <\eqnarray*>
          <tformat|<table|<row|<cell|<math-ss|I><around*|(|n|)>>|<cell|=>|<cell|O<around*|(|n*lg
          n*K<rsup|log<rsup|\<ast\>> n>|)>.>>>>
        </eqnarray*>

        What is the best <math|K> we can get?<vspace|2fn>
      </compact>
    </shown>|<\hidden*>
      <\compact>
        <strong|Frer>, after optimisation : <math|K=16> (?)

        <strong|We>, after optimisation : <math|K=8><vspace|2fn>
      </compact>
    </hidden*>|<\hidden*>
      <strong|Ingredients>

      <\itemize>
        <unroll|<\shown>
          <item>Multiplication in <math|\<bbb-Z\>> <math|\<rightsquigarrow\>>
          multiplication in <math|<around*|(|\<bbb-Z\>/<around*|\<nobracket\>|<around*|(|2<rsup|n>-1|)>*\<bbb-Z\>|\<nobracket\>>|)><around*|[|\<mathi\>|]>>.
        </shown>|<\hidden*>
          <item>One argument shared many times in recursive calls
          <math|\<rightsquigarrow\>> 2 DFTs instead of 3.
        </hidden*>|<\hidden*>
          <item>Convolution of length <math|N> with <math|b>-bit coefficients
          <math|\<rightsquigarrow\>> output of size <math|2*b+O<around*|(|lg
          N|)>>.

          Taking <math|b\<asymp\><around*|(|lg n|)><rsup|2>> instead of
          <math|b\<asymp\>lg n> improves the ratio
          <math|<around*|(|2*b+O<around*|(|lg N|)>|)>/b>.
        </hidden*>|<\hidden*>
          <item>Increase <math|R\<approx\>lg N>
          <math|<with|color|black|\<rightsquigarrow\>>>
          <math|R\<approx\><around*|(|lg N|)><rsup|lg lg
          N+O<around*|(|1|)>>>.

          Cost Bluestein\UKronecker <math|\<gg\>> cost twiddling and other.
        </hidden*>>
      </itemize>
    </hidden*>>
  </hidden>|<\hidden>
    <tit|Can we do even better?>

    <unroll|<\shown>
      <strong|Where does the cost come from?>

      <\compact>
        <\enumerate-alpha>
          <item>Factor <math|2> <math|<with|color|blue|\<leftsquigarrow\>>>
          Kronecker segmentation (<math|\<bbb-Z\><around*|[|\<mathi\>|]>\<rightsquigarrow\>\<bbb-C\><rsub|b><around*|[|X|]>>,
          cutting into pieces of <math|<frac|b|2>> bits)

          <item>Factor <math|2> <math|<with|color|blue|\<leftsquigarrow\>>>
          direct and inverse DFT

          <item>Factor <math|2> <math|<with|color|blue|\<leftsquigarrow\>>>
          Kronecker substitution (<math|\<bbb-C\><rsub|b><around*|[|X|]>/<around*|(|X<rsup|R>-1|)>\<rightsquigarrow\>\<bbb-Z\>/<around*|\<nobracket\>|<around*|(|2<rsup|2*b*R>-1|)>*\<bbb-Z\>|\<nobracket\>>>)
        </enumerate-alpha>
      </compact>
    </shown>|<\hidden*>
      <strong|Fermat primes>

      <\compact>
        And <em|if, <greyed|if>, <with|color|grey|if>> there were
        sufficiently many prime numbers of the form
        <math|p=2<rsup|2<rsup|k>>+1>

        (Optimized) Frer approach for <math|\<bbb-K\>=\<bbb-F\><rsub|p>>
        yields <math|K=4>

        Unfortunately..., <math|p=2<rsup|16>+1> is the largest known prime
        number of this form
      </compact>
    </hidden*>|<\hidden*>
      <strong|Mersenne primes>

      <\compact>
        <\conjecture>
          <label|mersenne-conj>Let <math|\<pi\><rsub|m><around*|(|x|)>=<around*|{|p\<leqslant\>x:p=2<rsup|q>-1,p<text|
          prime>,q<text| prime>|}>>. Then <math|\<exists\>a\<less\>b>,

          <\equation*>
            a*log log x\<less\>\<pi\><rsub|m><around*|(|x|)>\<less\>b*log log
            x
          </equation*>
        </conjecture>
      </compact>
    </hidden*>|<\hidden*>
      <strong|Crandall\UFagin algorithm>

      <\compact>
        Multiplication <math|\<bbb-F\><rsub|p><around*|[|\<mathi\>|]><around*|[|X|]>/<around*|(|X<rsup|M>-1|)>>
        <math|<with|color|black|\<rightsquigarrow\>>>
        <math|\<bbb-F\><rsub|p<rprime|'>><around*|[|\<mathi\>|]><around*|[|X,Y|]>/<rigid|<around*|(|X<rsup|M>-1,Y<rsup|N>-1|)>>>,
        <math|p<rprime|'>\<lll\>p>

        Conjecture<nbsp><reference|mersenne-conj> <math|\<Rightarrow\>>
        <math|K=4>
      </compact>
    </hidden*>>
  </hidden>>
</body>

<initial|<\collection>
</collection>>

<\references>
  <\collection>
    <associate|auto-1|<tuple|?|?>>
    <associate|auto-2|<tuple|<with|mode|<quote|math>|\<bullet\>>|?>>
    <associate|auto-3|<tuple|<with|mode|<quote|math>|\<bullet\>>|?>>
    <associate|auto-4|<tuple|<with|mode|<quote|math>|\<bullet\>>|?>>
    <associate|auto-5|<tuple|<with|mode|<quote|math>|\<bullet\>>|?>>
    <associate|mersenne-conj|<tuple|1|?>>
  </collection>
</references>

<\auxiliary>
  <\collection>
    <\associate|toc>
      <vspace*|1fn><with|font-series|<quote|bold>|math-font-series|<quote|bold>|Computational
      complexity> <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-1><vspace|0.5fn>

      <vspace*|1fn><with|font-series|<quote|bold>|math-font-series|<quote|bold>|Polynomial
      vs non-polynomial time for specific algorithmic problems>
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-2><vspace|0.5fn>

      <vspace*|1fn><with|font-series|<quote|bold>|math-font-series|<quote|bold>|Other
      algorithmic problems> <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-3><vspace|0.5fn>

      <vspace*|1fn><with|font-series|<quote|bold>|math-font-series|<quote|bold>|Programming
      language theory ...> <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-4><vspace|0.5fn>

      <vspace*|1fn><with|font-series|<quote|bold>|math-font-series|<quote|bold>|Other
      problems ...> <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-5><vspace|0.5fn>
    </associate>
  </collection>
</auxiliary>